<?php
session_start();

// Check if the user is logged in
if (!isset($_SESSION['loggedin']) || $_SESSION['loggedin'] !== true) {
    header('Location: login.php'); // Redirect to the login page if not logged in
    exit;
}
?>


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Text to Speech</title>
    <link rel="stylesheet" href="style.css?v=0.1" data-precedence="next"/>
</head>
<body>
    <textarea id="text-input" rows="5" placeholder="Enter your text here..."></textarea>
    <div id="text-stats"></div>

      <!-- Wrap the two select elements in a flexbox container -->
    <div class="select-container">

         <label for="narrator-select">Voice:</label>
        <select id="narrator-select" class="form-control">
            <option value="marcus">Marcus</option>
             <option value="neal">Neal</option>
            <option value="victoria">Victoria</option>
            <option value="nPczCjzI2devNBz1zQrb">Brian</option>
            <option value="JBFqnCBsd6RMkjVDRZzb">George</option>
             <option value="iP95p4xoKVk53GoZ742B">Chris</option>
             <option value="onwK4e9ZLuTAKqWW03F9">Daniel</option>
             <option value="pqHfZKP75CvOlQylNhV4">Bill</option>
             <option value="bIHbv24MWmeRgasZH58o">Will</option>
             <option value="pNInz6obpgDQGcFmaJgB">Adam</option>
        </select>
    </div>

    <input id="title-input" type="text" placeholder="Enter file name (optional)" style="width: 80%; margin-bottom: 10px; border-radius:10px;padding: 5px; font-size: 14px;box-shadow: inset 9px 9px 16px #bebebe, inset -9px -9px 16px #ffffff;border: 1px solid black;">
    <button onclick="confirmConversion()">Convert to Speech</button>
    <div id="audio-container"></div>
    <div id="elapsed-time">Time Taken: 0s</div>
    <div id="log-box"></div>

    <div id="progress">Progress: 0%</div>
    <div id="progress-bar">
        <div id="progress-bar-inner">
        </div>
    </div>

    <br>

<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('usage.php', '_blank', 'noopener,noreferrer')">
Fetch All Api Usage</button>
<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('addnewapikey.php', '_blank', 'noopener,noreferrer')">
    Add New API
</button>

    <br><br><br><br><br>

    <script>
        // Restore text and file name after a page refresh
        window.addEventListener('load', () => {
            const savedText = localStorage.getItem('text-input');
            const savedFileName = localStorage.getItem('title-input');
            if (savedText) document.getElementById('text-input').value = savedText;
            if (savedFileName) document.getElementById('title-input').value = savedFileName;

        });

        // Save inputs to local storage
        document.getElementById('text-input').addEventListener('input', () => {
            localStorage.setItem('text-input', document.getElementById('text-input').value);
        });
        document.getElementById('title-input').addEventListener('input', () => {
            localStorage.setItem('title-input', document.getElementById('title-input').value);
        });


        // Reference to the textarea and text stats container
        const textArea = document.getElementById("text-input");
        const textStats = document.getElementById("text-stats");
        // Text stats calculation
        textArea.addEventListener("input", updateTextStats);
        function updateTextStats() {
            const text = textArea.value;
            const charCount = text.length;
            const wordCount = text.trim().split(/\s+/).filter(Boolean).length; // Avoid counting empty strings as words
            const paragraphCount = text.split(/\n\s*\n/).filter(Boolean).length; // Avoid counting empty strings as paragraphs

            textStats.textContent = `Characters: ${charCount} | Words: ${wordCount} | Paragraphs: ${paragraphCount}`;
        }

        function splitTextIntoChunks(text, chunkSize = 400) {
            const chunks = [];
            const paragraphs = text.split(/\n+/); // Split text into paragraphs

            paragraphs.forEach(paragraph => {

                paragraph = paragraph.replace(/[*#\[\]\(\)]/g, ' ') // Remove * # and brackets
                    .replace(/-{2,}/g, '') // Reduce two or more dashes to one
                    .replace(/\s+/g, ' ') // Replace multiple spaces with one space
                    .trim(); // Remove leading and trailing spaces

                if (paragraph.length === 0) return; // Skip if the paragraph is empty

                let start = 0;

                while (start < paragraph.length) {
                    let end = start + chunkSize;

                    if (end < paragraph.length) {
                        // Find the last punctuation before the chunk ends
                        let lastPunctuation = Math.max(
                            paragraph.lastIndexOf('.', end),
                            paragraph.lastIndexOf('!', end),
                            paragraph.lastIndexOf('?', end),
                            paragraph.lastIndexOf(',', end),
                             paragraph.lastIndexOf('।', end),
                             paragraph.lastIndexOf(':', end)
                        );

                        // Fallback to the last space if no punctuation or punctuation is too close to start
                        if (lastPunctuation > start) {
                            end = lastPunctuation + 1; // Include punctuation
                        } else {
                            let lastSpace = paragraph.lastIndexOf(' ', end);
                            if (lastSpace > start) {
                                end = lastSpace; // Fall back to the last space
                            }
                        }
                    }

                    const chunk = paragraph.slice(start, end).trim();
                    if (chunk.length > 0) {
                        chunks.push(chunk); // Add the chunk only if it's not empty
                    }
                    start = end;
                }
            });

            return chunks;
        }

        // Added confirmation dialog
        function confirmConversion() {
            if (confirm("Are you sure you want to convert the text? This will clear the previous audio.")) {
                convertTextToSpeech();
            }
        }

        // Initialize API Stats
         const PaidapiUrls = [
"https://paid2.amar185.workers.dev/",
"https://damp-union-c166.amar590.workers.dev/",
"https://little-tree-c94e.amar50.workers.dev/",
"https://red-frost-3298.amar931.workers.dev/",
"https://gentle-dawn-3974.amar246.workers.dev/",
"https://still-truth-ec18.amar235.workers.dev/",
"https://falling-cake-df02.amar749.workers.dev/",
"https://new.amar919.workers.dev/",
"https://new.amar904.workers.dev/",
"https://new.amarsir.workers.dev/",
"https://new.amarkoiri9.workers.dev/",
"https://new.amarkoiri608.workers.dev/",
"https://new.amarkoiri823.workers.dev/",
"https://sweet-boat-ea88.amarkoiri687.workers.dev/",
"https://new.amarkoiri754.workers.dev/",
"https://new.amarkoiri963.workers.dev/",
"https://new.worker1-54d.workers.dev/",
"https://new.amar423.workers.dev/",
"https://new.amar465.workers.dev/",
"https://new.amar385.workers.dev/",
"https://new.amarkoiri244.workers.dev/",
"https://paid.amar185.workers.dev/"
         ];
        const FreeapiUrls = [
"https://nameless-shape-e4e0.cherry617.workers.dev/",
"https://square-king-650a.amar185.workers.dev/",
"https://black-moon-7e5d.cherry1.workers.dev/",
"https://silent-meadow-7072.cherry2269.workers.dev/",
"https://ancient-star-c75a.cherry805.workers.dev/",
"https://holy-poetry-6051.cherry740.workers.dev/",
"https://little-moon-5f5f.cherry403.workers.dev/",
"https://winter-cloud-4ff2.cherry627.workers.dev/",
"https://orange-cell-f9be.cherry228.workers.dev/",
"https://wild-heart-a0ba.cherry539.workers.dev/",
"https://1.amarkoiri244.workers.dev/",
"https://1.amar423.workers.dev/",
"https://1.amarkoiri608.workers.dev/",
"https://1.amar465.workers.dev/",
"https://1.amar385.workers.dev/",
"https://1.worker1-54d.workers.dev/",
"https://1.amarkoiri963.workers.dev/",
"https://1.amarkoiri754.workers.dev/",
"https://1.amarkoiri687.workers.dev/",
"https://1.amarkoiri823.workers.dev/"
];

        async function convertTextToSpeech() {
             const narratorSelect = document.getElementById('narrator-select');
            const selectedNarrator = narratorSelect.value;

            const text = document.getElementById('text-input').value;
            const elapsedTimeDisplay = document.getElementById('elapsed-time');
            const titleInput = document.getElementById('title-input').value.trim();
            const audioContainer = document.getElementById('audio-container');
            const logBox = document.getElementById('log-box');
            const progressIndicator = document.getElementById('progress');
            const progressBar = document.getElementById('progress-bar-inner');

            logBox.innerHTML = '';
            audioContainer.innerHTML = '';
            elapsedTimeDisplay.textContent = 'Time Taken: 0s';

            if (text.length === 0) {
                  return;
            }

            const startTime = Date.now();
            let timerInterval;

            function startTimer() {
                timerInterval = setInterval(() => {
                    const elapsedTimeInSeconds = (Date.now() - startTime) / 1000;
                    const hours = Math.floor(elapsedTimeInSeconds / 3600);
                    const minutes = Math.floor((elapsedTimeInSeconds % 3600) / 60);
                    const seconds = Math.floor(elapsedTimeInSeconds % 60);
                    const formattedTime = `${hours.toString().padStart(2, '0')}h:${minutes.toString().padStart(2, '0')}m:${seconds.toString().padStart(2, '0')}s`;
                    elapsedTimeDisplay.textContent = `Time Taken: ${formattedTime}`;
                }, 1000);
            }

            function stopTimer() {
                clearInterval(timerInterval);
            }

            startTimer();
            const chunks = splitTextIntoChunks(text, 400);
             const audioBlobs = [];
              let completedChunks = 0;
            let apiKeys = [];
            let apiNames = [];
             let apiVoiceIds = [];

             try {
                 const apiData = await loadApis();
                apiKeys = apiData.apis.map(api => api["xi-api-key"]);
                apiNames = apiData.apis.map(api => api.name);
                 apiVoiceIds = apiData.apis.map(api => api.voice_ids);
                  if(apiKeys.length === 0 && selectedNarrator !== "marcus" && selectedNarrator !== "neal" && selectedNarrator !== "victoria" ){
                    //do not show alert when its a free voice
                   }else if(apiKeys.length === 0){
                   alert("No API Key Found!");
                   return;
                    }
            } catch (error) {
                     console.error("Error loading APIs:", error);
                 alert("An error occurred while loading APIs. Please try again.");
                 return;
            }
             let chunkIndex = 0;
             async function processChunk() {
                    if (chunkIndex >= chunks.length) {
                           const mergedBlob = new Blob(audioBlobs, { type: 'audio/mpeg' });
                           const audioUrl = URL.createObjectURL(mergedBlob);
                            const currentTime = new Date().toISOString().replace(/[:.]/g, '-');
                            const fileName = titleInput ? `${titleInput}-${currentTime}.mp3` : `${currentTime}.mp3`;


                                 audioContainer.innerHTML = `
                                    <audio id="generated-audio" controls>
                                        <source src="${audioUrl}" type="audio/mpeg">
                                        Your browser does not support the audio element.
                                    </audio>
                                    <a href="${audioUrl}" download="${fileName}">Download Audio</a>
                                `;
                                stopTimer();
                               progressIndicator.textContent = 'Progress: 100% - Conversion Complete!';
                                progressBar.style.width = '100%';
                                updateLogBox('<p>Conversion complete!</p>');

                                document.getElementById('generated-audio').play();
                         return;
                    }


                    let chunk = chunks[chunkIndex];
                    let success = false;
                    let retries = 0;
                     let currentApiUrl = null;
                     let apiKeyIndex = 0;
                     let apiKey = null;
                     let currentApiKeyName = null;
                     let currentVoiceId = null;
                      let headers = {
                            'Content-Type': 'application/json',
                         };
                     if(selectedNarrator === "marcus" || selectedNarrator === "neal" || selectedNarrator === "victoria"){
                            currentApiUrl = PaidapiUrls[chunkIndex % PaidapiUrls.length];
                           while (!success && retries < 1000) {
                            apiKey = apiKeys[apiKeyIndex % apiKeys.length];
                            currentApiKeyName = apiNames[apiKeyIndex % apiNames.length];
                            const voiceIds = apiVoiceIds[apiKeyIndex % apiVoiceIds.length];

                             if(voiceIds && voiceIds[selectedNarrator]){
                                 currentVoiceId = voiceIds[selectedNarrator];
                             } else {
                                    updateLogBox(`<p style="color:red;">Error: Voice ID not found for ${selectedNarrator} with key ${currentApiKeyName}. Trying next API.</p>`);
                                    retries++;
                                    currentApiUrl = PaidapiUrls[(chunkIndex + retries) % PaidapiUrls.length];
                                    apiKeyIndex++;
                                    if (apiKeyIndex >= apiKeys.length) {
                                          apiKeyIndex = 0;
                                    }
                                    continue;
                                }
                                headers['xi-api-key'] = apiKey;
                            updateLogBox(`<p>Sending chunk no ${chunkIndex + 1} \n ${chunk}\nusing API URL: ${currentApiUrl}. Using API Key: ${currentApiKeyName}. Voice ID: ${currentVoiceId} . Retry count: ${retries}</p>`);
                            logBox.scrollTop = logBox.scrollHeight;
                                try {
                                 const response = await fetch(currentApiUrl + "?v=" + Math.random().toString(36).substring(7), {
                                        method: 'POST',
                                        headers: headers,
                                        body: JSON.stringify({ text: chunk, narratorId: currentVoiceId, xiapikey: apiKey }),
                                    });

                                    if (response.ok && response.headers.get("Content-Type").includes("audio")) {
                                        const blob = await response.blob();
                                        audioBlobs.push(blob);
                                        success = true;
                                        completedChunks++;

                                        const progressPercentage = Math.round((completedChunks / chunks.length) * 100);
                                        progressIndicator.textContent = `Progress: ${progressPercentage}%`;
                                        progressBar.style.width = `${progressPercentage}%`;
                                    } else {
                                        retries++;
                                        currentApiUrl = PaidapiUrls[(chunkIndex + retries) % PaidapiUrls.length];
                                        apiKeyIndex++;
                                        if (apiKeyIndex >= apiKeys.length) {
                                              apiKeyIndex = 0;
                                         }
                                          const errorData = await response.json();
                                        updateLogBox(`<p style="color:red;">Error on chunk ${chunkIndex + 1}: ${errorData.detail.status}. Retry ${retries}/1000...</p>`);

                                      }
                                 } catch (error) {
                                       retries++;
                                        currentApiUrl = PaidapiUrls[(chunkIndex + retries) % PaidapiUrls.length];
                                        apiKeyIndex++;
                                        if (apiKeyIndex >= apiKeys.length) {
                                              apiKeyIndex = 0;
                                         }
                                       updateLogBox(`<p style="color:red;">Network error on chunk ${chunkIndex + 1}: ${error.message}. Retry ${retries}/1000...</p>`);
                                   }
                             }


                     } else {

                         currentApiUrl = FreeapiUrls[chunkIndex % FreeapiUrls.length];
                            currentVoiceId = selectedNarrator;
                        while (!success && retries < 1000) {

                            updateLogBox(`<p>Sending chunk no ${chunkIndex + 1} \n ${chunk}\nusing Free API URL: ${currentApiUrl}. Using Voice ID: ${currentVoiceId} . Retry count: ${retries}</p>`);
                                logBox.scrollTop = logBox.scrollHeight;
                            try {
                                const response = await fetch(currentApiUrl + "?v=" + Math.random().toString(36).substring(7), {
                                    method: 'POST',
                                    headers: headers,
                                    body: JSON.stringify({ text: chunk, narratorId: currentVoiceId }),
                                });


                                if (response.ok && response.headers.get("Content-Type").includes("audio")) {
                                    const blob = await response.blob();
                                    audioBlobs.push(blob);
                                    success = true;
                                     completedChunks++;

                                     const progressPercentage = Math.round((completedChunks / chunks.length) * 100);
                                    progressIndicator.textContent = `Progress: ${progressPercentage}%`;
                                    progressBar.style.width = `${progressPercentage}%`;
                                } else {
                                   retries++;
                                   currentApiUrl = FreeapiUrls[(chunkIndex + retries) % FreeapiUrls.length];

                                     const errorData = await response.json();
                                    updateLogBox(`<p style="color:red;">Error on chunk ${chunkIndex + 1}: ${errorData.detail.status}. Retry ${retries}/1000...</p>`);

                                 }
                            } catch (error) {
                                retries++;
                                currentApiUrl = FreeapiUrls[(chunkIndex + retries) % FreeapiUrls.length];
                                    updateLogBox(`<p style="color:red;">Network error on chunk ${chunkIndex + 1}: ${error.message}. Retry ${retries}/1000...</p>`);
                            }
                        }

                     }



                    if (!success) {
                        updateLogBox(`<p style="color:red;">Failed to convert chunk ${chunkIndex + 1} after 1000 attempts.</p>`);
                      }
                    chunkIndex++;
                   processChunk();
             }
            processChunk();
        }

        // Function to limit logs in the logBox
        function updateLogBox(newLog) {
             const logBox = document.getElementById('log-box');
             logBox.innerHTML += newLog;
            const logs = logBox.getElementsByTagName('p');

            // Remove all but the last two logs
            while (logs.length > 50) {
                logBox.removeChild(logs[0]);
            }

            logBox.scrollTop = logBox.scrollHeight; // Ensure the latest log is visible
        }

        // Global variable for usage table container
         const fetchAllUsageButton = document.getElementById("fetchAllUsageButton");
         const goToLinkButton = document.getElementById("goToLinkButton");


       async function loadApis() {
              const cachedData = localStorage.getItem('apiData');
              const cachedTime = localStorage.getItem('apiDataTime');
              const now = Date.now();
           if (cachedData && cachedTime && now - parseInt(cachedTime) < 24 * 60 * 60 * 1000) {
                  try {
                    return JSON.parse(cachedData);
                    } catch (e) {
                    console.error("Error parsing cached API data:", e);
                       localStorage.removeItem('apiData');
                        localStorage.removeItem('apiDataTime');
                   }
                }
                try {
                   const response = await fetch("APIs.json");
                     const data = await response.json();
                    localStorage.setItem('apiData', JSON.stringify(data));
                   localStorage.setItem('apiDataTime', now.toString());
                  return data;
                  } catch (error) {
                    console.error("Error loading APIs:", error);
                     throw error;
                  }
       }


        // Load APIs when the page is ready
        window.addEventListener("load", async () => {
            try {
              await loadApis();
            } catch (error) {
               console.error("Failed to load APIs on page load:", error);
             }
         });
    </script>
</body>
</html>