<?php
// Enable error reporting for debugging during development
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

// Path to cookies file
$dataFile = 'cookies.json';

// Load cookies data if file exists
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];

$email = isset($_GET['email']) ? $_GET['email'] : null;
$auth_session = null;

// Validate email and check if it exists in the cookies file
if ($email && isset($data[$email])) {
    $auth_session = $data[$email]['cookie'];
} else {
    echo json_encode(['error' => 'Email not found']);
    exit;
}


$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.loginWithPassword?batch=1',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_HEADER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS => '{"0":{"json":{"email":"' . $email . '","password":"' . $email . '"}}}',
  CURLOPT_COOKIE => 'NEXT_LOCALE=en',
  CURLOPT_HTTPHEADER => [
    'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.200 Mobile Safari/537.36',
    'Accept-Encoding: gzip, deflate, br, zstd',
    'Content-Type: application/json',
    'sec-ch-ua-platform: "Android"',
    'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
    'sec-ch-ua-mobile: ?1',
    'origin: https://stablediffusionweb.com',
    'x-requested-with: mark.via.gp',
    'sec-fetch-site: same-origin',
    'sec-fetch-mode: cors',
    'sec-fetch-dest: empty',
    'referer: https://stablediffusionweb.com/auth/login',
    'accept-language: en-US,en;q=0.9',
    'priority: u=1, i',
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);
$http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
$header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
$headers = substr($response, 0, $header_size);
$body = substr($response, $header_size);

curl_close($curl);

if ($err) {
      echo json_encode(['error' => 'cURL Error #: ' . $err]);
      exit;
} else if ($http_code !== 200){
    echo json_encode(['error' => 'HTTP Error Code : ' . $http_code . '  Response: ' . $response]);
    exit;
}

// Extract auth_session cookie
if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
        $new_auth_session = $matches[1];
         $data[$email]['cookie'] = $new_auth_session;
}
// Parse response and update user data
    $responseData = json_decode($body, true);
    if (isset($responseData[0]['result']['data']['json'])) {
        $userData = $responseData[0]['result']['data']['json'];
         $data[$email]['user'] = $userData['user'];
         $data[$email]['sessionId'] = $userData['sessionId'];
        file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
           echo json_encode(['success' => 'Login Successful', 'email' => $email]);
     }else{
          echo json_encode(['error' => 'Login failed: '. $response]);
     }

?>