<?php
$dataFile = 'cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, viewport-fit=cover">
    <title>Image Generation</title>
    <style>
        body {
            font-family: 'Arial', sans-serif;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: flex-start;
            min-height: 100vh;
            margin: 20px;
            background-color: #f0f0f0;
            color: #333;
        }
          h1 {
             color: #2c3e50;
             margin-bottom: 20px;
             text-align: center;
          }
          #email-selector {
             width: 90%;
              max-width: 600px;
              margin-bottom: 20px;
            display: flex;
            align-items: center;
             justify-content: center;

        }

         #email-selector select{
              padding: 10px;
               border: none;
              border-radius: 10px;
              box-sizing: border-box;
                background: #e0e0e0;
              box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff;
                 margin-right: 10px;
                  outline: none;
          }
         #email-selector button{
             background-color: #f0f0f0;
            color: #2c3e50;
            padding: 10px 15px;
            border: none;
            border-radius: 10px;
           cursor: pointer;
             box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
            transition: background-color 0.3s ease;
            margin-bottom: 10px;
               outline: none;
         }
         #email-selector button:hover {
              background-color: #e0e0e0;
          }


         #content-container {
             width: 95%;
             max-width: 800px;
             display: none;
           }

         #content-container.show {
              display: flex;
             flex-direction: column;
              align-items: center;
          }


         form {
             background-color: #f0f0f0;
            padding: 20px;
           border-radius: 15px;
              box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
            width: 100%;
             max-width: 600px;
            display: flex;
             flex-direction: column;
            align-items: center;
             transition: transform 0.3s ease-in-out;
             margin-bottom: 20px;
             box-sizing: border-box;

         }
          form:hover {
            transform: scale(1.02);
        }

        textarea {
           width: calc(100% - 22px);
            padding: 10px;
             margin-bottom: 15px;
             border: none;
              border-radius: 10px;
            box-sizing: border-box;
             background: #e0e0e0;
           box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff;
             font-family: inherit;
           min-height: 80px;
           resize: vertical;
              outline: none;
        }

          button {
             background-color: #f0f0f0;
            color: #2c3e50;
            padding: 10px 15px;
             border: none;
             border-radius: 10px;
             cursor: pointer;
              box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
            transition: background-color 0.3s ease;
            margin-bottom: 10px;
              outline: none;
         }
          button:hover {
               background-color: #e0e0e0;
          }
         #status {
             text-align: center;
           margin-top: 15px;
             font-weight: bold;
        }
         #image-container {
             margin-top: 15px;
           text-align: center;
          }

        #image-container img {
           max-width: 100%;
             max-height: 200px;
              border-radius: 10px;
          }

         #history-container {
           margin-top: 20px;
           width: 100%;
            }

         #history-container ul{
              list-style: none;
             padding: 0;
          }

         #history-container li {
            border: none;
            border-radius: 10px;
             padding: 15px;
            margin-bottom: 15px;
             background: #f0f0f0;
            box-shadow:  5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
            display: flex;
              flex-wrap: wrap;
             box-sizing: border-box;
              align-items: center;
          }

           .image-item-image{
              flex: 0 0 40%;
              padding-right: 10px;
              display: flex;
               align-items: center;
                justify-content: center;
            }
           .image-item-details {
              flex: 0 0 60%;
            padding-left: 10px;
             box-sizing: border-box;
            }

            .image-item-details p{
                margin: 5px 0;
                word-wrap: break-word;
             }
           .download-btn {
             background-color: #2ecc71;
               color: white;
              border: none;
            padding: 8px 12px;
             border-radius: 8px;
             cursor: pointer;
              transition: background-color 0.3s ease;
                display: inline-block;
             margin-top: 10px;
              outline: none;
          }
              .download-btn:hover{
               background-color: #27ae60;
            }
             .btn-container{
              text-align: right;
                 margin-top: 5px;
           }
          /* Mobile Styles */
          @media (max-width: 600px) {
             #history-container li {
                 flex-direction: column;
            }
                .image-item-image{
                flex: 0 0 100%;
                   padding-right: 0;
                 }
                .image-item-details {
                  flex: 0 0 100%;
                   padding-left: 0;
               }
              #image-container img {
                    max-width: 100%;
                     max-height: auto;
                 }
                .image-item-image img{
                    max-width: 100%;
                     max-height: 150px;
                 }
                 #history-container li {
                     display: flex;
                     flex-wrap: wrap;
                     flex-direction: row;
                     justify-content: center;
                   align-items: stretch;
                 }
             }

       #login-btn {
             background-color: #f0f0f0;
            color: #2c3e50;
            padding: 10px 15px;
             border: none;
            border-radius: 10px;
           cursor: pointer;
            box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
            transition: background-color 0.3s ease;
             margin-bottom: 10px;
              outline: none;
          }
         #login-btn:hover {
               background-color: #e0e0e0;
           }
           .dimension-options {
                 display: flex;
                justify-content: center;
                align-items: center;
                margin-bottom: 10px;
            }

           .dimension-options label {
              margin: 0 5px;
            }

            .dimension-options select{
                padding: 8px;
                border: none;
               border-radius: 10px;
                box-sizing: border-box;
                 background: #e0e0e0;
                box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff;
                 margin-right: 10px;
                    outline: none;
            }

    </style>
</head>
<body>
    <h1>Image Generator</h1>
    <div id="email-selector">
      <select id="emailDropdown">
         <option value="">Select an Email</option>
            <?php
            if (!empty($data)) {
               foreach ($data as $email => $value) {
                  echo "<option value='" . htmlspecialchars($email) . "'>" . htmlspecialchars($email) . "</option>";
               }
            }
            ?>
       </select>
       <button onclick="loadContent()">Go</button>
    </div>
    <div id="content-container">
       <div id="user-details-container" class="user-details"></div>
       <form id="imageForm">
           <textarea id="prompt" placeholder="Enter your prompt here">A hyper realistic, highly detailed image of an old book mockup titled "Control Your Mouth & Mind". The book mockup should be placed on a natural bokeh background. In the footer of the book cover, include the Author name "AudioBook Legends" with an old typography which is clearly visible, also add relevant elements from title in the book cover.</textarea>
             <div class="dimension-options">
              <label for="dimensionPreset">Select Dimension:</label>
              <select id="dimensionPreset">
                 <option value="custom">Custom Input</option>
                  <option value="book">Book Mockup 1:1</option>
                 <option value="thumbnail">Thumbnail 9:16</option>
               </select>
          </div>
           <div class="dimensions">
              <input type="number" id="width" placeholder="Width" value="1024">
              <input type="number" id="height" placeholder="Height" value="1024">
           </div>
           <button type="submit">Generate Image</button>
            <div id="status"></div>
      </form>
     <div id="image-container"></div>
    <div id="history-container"></div>
    </div>
     <script>
        const contentContainer = document.getElementById('content-container');
         let currentEmail = null;

         function updateDimensionInputs(preset) {
                const widthInput = document.getElementById('width');
                const heightInput = document.getElementById('height');
              switch (preset) {
                  case 'book':
                      widthInput.value = 1024;
                        heightInput.value = 1024;
                    break;
                 case 'thumbnail':
                      widthInput.value = 720;
                        heightInput.value = 1080;
                      break;
                  case 'custom':
                      break;
               }
         }
        function loadContent() {
          const emailDropdown = document.getElementById('emailDropdown');
           const selectedEmail = emailDropdown.value;
          if(!selectedEmail) return;
             currentEmail = selectedEmail;
             contentContainer.classList.add('show');
             contentContainer.innerHTML = '';
              contentContainer.innerHTML = `  <div id="user-details-container" class="user-details"></div>
                <form id="imageForm">
                    <textarea id="prompt" placeholder="Enter your prompt here">A hyper realistic, highly detailed image of an old book mockup titled "Control Your Mouth & Mind". The book mockup should be placed on a natural bokeh background. In the footer of the book cover, include the Author name "AudioBook Legends" with an old typography which is clearly visible, also add relevant elements from title in the book cover.</textarea>
                    <div class="dimension-options">
                        <label for="dimensionPreset">Select Dimension:</label>
                            <select id="dimensionPreset">
                                <option value="custom">Custom Input</option>
                                 <option value="book">Book Mockup 1:1</option>
                                  <option value="thumbnail">Thumbnail 9:16</option>
                            </select>
                    </div>
                     <div class="dimensions">
                        <input type="number" id="width" placeholder="Width" value="1024">
                         <input type="number" id="height" placeholder="Height" value="1024">
                    </div>
                    <button type="submit">Generate Image</button>
                    <div id="status"></div>
                  </form>
                   <div id="image-container"></div>
                   <div id="history-container"></div>`;

             const userDetailsContainer = document.getElementById('user-details-container');
            const historyContainer = document.getElementById('history-container');

            const dimensionPresetDropdown = document.getElementById('dimensionPreset');
             dimensionPresetDropdown.addEventListener('change', () => {
                 updateDimensionInputs(dimensionPresetDropdown.value);
              });
           updateDimensionInputs(dimensionPresetDropdown.value)
            //Fetch and Display user details
               function fetchAndDisplayUserDetails(){
                    fetch('getUserDetails.php?email=' + selectedEmail)
                     .then(response => response.json())
                      .then(data => {
                           if (data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json) {
                                const user = data[0].result.data.json;
                                const nextResetDate = new Date(user.next_reset_date);
                                const formattedResetDate = nextResetDate.toLocaleDateString(undefined, {
                                      year: 'numeric',
                                      month: 'long',
                                       day: 'numeric',
                                       hour: 'numeric',
                                      minute: 'numeric'
                                   });
                                 const userDetailsHTML = `
                                        <p><strong>Email:</strong> ${user.email}</p>
                                        <p><strong>Credits Left:</strong> ${user.credits}</p>
                                        <p><strong>Next Reset Date:</strong> ${formattedResetDate}</p>
                                `;
                                 userDetailsContainer.innerHTML = userDetailsHTML;
                             } else {
                                userDetailsContainer.innerHTML = '<button id="login-btn" onclick="window.location.href=\'authLoginWithPassword.php?email='+selectedEmail+'\'">Login</button>';
                             }
                     })
                   .catch(error => {
                           userDetailsContainer.innerHTML = '<button id="login-btn" onclick="window.location.href=\'authLoginWithPassword.php?email='+selectedEmail+'\'">Login</button>';
                        console.error('Error:', error);
                    });
                }
                 fetchAndDisplayUserDetails();




             // Fetch and display image history on page load
                function fetchAndDisplayHistory() {
                  fetch('imageHistory.php?email=' + selectedEmail)
                     .then(response => response.json())
                      .then(data => {
                           if(data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json){
                               const history = data[0].result.data.json;
                                  let historyHTML = '<ul>';
                                      history.forEach(item => {
                                  historyHTML += `<li>
                                         <div class="image-item-image"><img src="${item.s3_url}" alt="Generated Image"></div>
                                         <div class="image-item-details">
                                              <p><strong>Prompt:</strong> ${item.input_prompt}</p>
                                             <p><strong>Created At:</strong> ${item.created_at}</p>
                                            <div class="btn-container"><a class="download-btn" href="${item.s3_url}" download="image.jpg">Download</a></div>
                                         </div>
                                       </li>`;
                                     });
                                 historyHTML += '</ul>';
                                 historyContainer.innerHTML = historyHTML;
                            } else {
                                 historyContainer.innerHTML = 'No images found in history.';
                            }

                      })
                     .catch(error=>{
                          historyContainer.innerHTML = 'Error fetching image history.';
                          console.error('Error:', error)
                       });

                }
               fetchAndDisplayHistory();

               document.getElementById('imageForm').addEventListener('submit', function(event) {
                 event.preventDefault();
                 const prompt = document.getElementById('prompt').value;
                  const width = document.getElementById('width').value;
                  const height = document.getElementById('height').value;
                   const statusDiv = document.getElementById('status');
                   const imageContainer = document.getElementById('image-container');
                    statusDiv.textContent = 'Generating...';
                  imageContainer.innerHTML = '';


                     fetch('addTask.php?email='+selectedEmail, {
                         method: 'POST',
                          headers: {
                              'Content-Type': 'application/x-www-form-urlencoded',
                          },
                           body: 'prompt=' + encodeURIComponent(prompt) + '&width=' + encodeURIComponent(width) + '&height=' + encodeURIComponent(height),
                      })
                      .then(response => response.json())
                     .then(data => {
                          if (data && data.error) {
                               statusDiv.textContent = 'Error: ' + data.error;
                          } else if(data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json && data[0].result.data.json[0]){
                               const uuid = data[0].result.data.json[0].uuid;
                              statusDiv.textContent = 'Status: ' + data[0].result.data.json[0].status;
                               // Start Polling function
                               pollForImage(uuid,statusDiv,imageContainer,selectedEmail,historyContainer,userDetailsContainer);
                           } else {
                               statusDiv.textContent = 'Error generating image.';
                           }
                   })
                     .catch(error => {
                         statusDiv.textContent = 'Error generating image.';
                          console.error('Error:', error);
                    });
                });

               function pollForImage(uuid,statusDiv,imageContainer,email,historyContainer,userDetailsContainer) {
                 const interval = setInterval(() => {
                      fetch('getTask.php?email=' + email, {
                             method: 'POST',
                            headers: {
                                 'Content-Type': 'application/x-www-form-urlencoded',
                           },
                          body: 'uuid=' + encodeURIComponent(uuid),
                       })
                       .then(response => response.json())
                         .then(data => {
                            if (data && data.error) {
                                statusDiv.textContent = 'Error: ' + data.error;
                                 clearInterval(interval);
                            } else if(data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json && data[0].result.data.json[0]){
                                  const task = data[0].result.data.json[0];
                                 statusDiv.textContent = 'Status: ' + task.status;
                                if (task.status === 'completed' && task.s3_url) {
                                     clearInterval(interval);
                                      imageContainer.innerHTML = `<img src="${task.s3_url}" alt="Generated Image">`;
                                    statusDiv.textContent = 'Image Generated Successfully';
                                      fetchAndDisplayHistory();
                                      fetchAndDisplayUserDetails();
                                } else if (task.status === 'error') {
                                    clearInterval(interval);
                                   statusDiv.textContent = 'Error: ' + task.error_message;
                               }
                           } else {
                              statusDiv.textContent = 'Error generating image.';
                                 clearInterval(interval);
                           }
                       })
                      .catch(error => {
                           statusDiv.textContent = 'Error generating image.';
                            clearInterval(interval);
                           console.error('Error:', error);
                       });

                 }, 1000); // Check every 1 second
            }
        }

    </script>
</body>
</html>