<?php

// Load the JSON file
$dataFile = 'cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];

// Check if the request is POST
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $email = $_POST['email'];
    $otp = $_POST['otp'];

    if (!isset($data[$email])) {
        die("Error: No signup data found for this email.");
    }

    $auth_session = $data[$email]['cookie'];

    $postFields = '{"0":{"json":{"code":"' . $otp . '","type":"SIGNUP","identifier":"' . $email . '"}}}';

    $curl = curl_init();

    curl_setopt_array($curl, [
        CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.verifyOtp?batch=1',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_HEADER => true,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => $postFields,
        CURLOPT_COOKIE => 'NEXT_LOCALE=en; auth_session=' . $auth_session,
    CURLOPT_HTTPHEADER => [
    'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
 //   'Accept-Encoding: gzip, deflate, br, zstd',
    'Content-Type: application/json',
    'sec-ch-ua-platform: "Android"',
    'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
    'sec-ch-ua-mobile: ?1',
    'origin: https://stablediffusionweb.com',
    'x-requested-with: mark.via.gp',
    'sec-fetch-site: same-origin',
    'sec-fetch-mode: cors',
    'sec-fetch-dest: empty',
    'referer: https://stablediffusionweb.com/auth/otp?type=SIGNUP&redirectTo=%2Fapp&identifier=$email',
    'accept-language: en-US,en;q=0.9',
    'priority: u=1, i',
  ],
    ]);

    $response = curl_exec($curl);
    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
    $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
    $headers = substr($response, 0, $header_size);
    $body = substr($response, $header_size);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err || $http_code !== 200) {
        die("Error: " . ($err ?: $response));
    }

    // Extract new auth_session cookie and update JSON
    if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
        $new_auth_session = $matches[1];
        $data[$email]['cookie'] = $new_auth_session;
    }

    // Parse response and update user data
    $responseData = json_decode($body, true);
    if (isset($responseData[0]['result']['data']['json'])) {
        $userData = $responseData[0]['result']['data']['json'];
        $data[$email]['user'] = $userData['user'];
        $data[$email]['sessionId'] = $userData['sessionId'];
        $data[$email]['state'] = $userData['state'];
        file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
        echo "OTP Verified Successfully. User data and updated cookie saved.<br>";
        echo '<a href="index.html">Go Back</a>';
    } else {
        echo "Error verifying OTP: " . $response;
    }
} else {
    echo "Invalid request.";
}
