<?php
// Load or initialize the JSON file
$dataFile = 'cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];
$message = "";
$showSignupForm = true;
$showOtpForm = false;
$email = "";

if (isset($_POST['action'])) {
    if ($_POST['action'] == 'signup') {
        $email = $_POST['email'];
        $password = $email; // Same as email
        $name = $email;

        $curl = curl_init();

        curl_setopt_array($curl, [
            CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.signup?batch=1',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_HEADER => true,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => '{"0":{"json":{"email":"' . $email . '","password":"' . $password . '","name":"' . $name . '","callbackUrl":"https://stablediffusionweb.com/auth/verify"}}}',
            CURLOPT_COOKIE => 'NEXT_LOCALE=en',
        CURLOPT_HTTPHEADER => [
            'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
            'Accept-Encoding: gzip, deflate, br, zstd',
            'Content-Type: application/json',
            'sec-ch-ua-platform: "Android"',
            'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
            'sec-ch-ua-mobile: ?1',
            'origin: https://stablediffusionweb.com',
            'x-requested-with: mark.via.gp',
            'sec-fetch-site: same-origin',
            'sec-fetch-mode: cors',
            'sec-fetch-dest: empty',
            'referer: https://stablediffusionweb.com/auth/signup',
            'accept-language: en-US,en;q=0.9',
            'priority: u=1, i',
        ],
        ]);

        $response = curl_exec($curl);
        $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
        $headers = substr($response, 0, $header_size);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err || $http_code !== 200) {
            $message = "Error: " . ($err ?: $response);
        } else {
              // Extract auth_session cookie
            if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
                $auth_session = $matches[1];
                $data[$email] = ['cookie' => $auth_session];
                file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
                $message = "Signup successful! Please verify OTP.";
                $showSignupForm = false;
                $showOtpForm = true;
            } else {
                $message = "No auth_session cookie found.";
            }
           
        }
    } else if ($_POST['action'] == 'otpverify') {
        $email = $_POST['email'];
        $otp = $_POST['otp'];

        if (!isset($data[$email])) {
            $message = "Error: No signup data found for this email.";
        } else {
          $auth_session = $data[$email]['cookie'];

          $postFields = '{"0":{"json":{"code":"' . $otp . '","type":"SIGNUP","identifier":"' . $email . '"}}}';

          $curl = curl_init();

          curl_setopt_array($curl, [
              CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.verifyOtp?batch=1',
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_HEADER => true,
              CURLOPT_CUSTOMREQUEST => 'POST',
              CURLOPT_POSTFIELDS => $postFields,
              CURLOPT_COOKIE => 'NEXT_LOCALE=en; auth_session=' . $auth_session,
          CURLOPT_HTTPHEADER => [
          'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
       //   'Accept-Encoding: gzip, deflate, br, zstd',
          'Content-Type: application/json',
          'sec-ch-ua-platform: "Android"',
          'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
          'sec-ch-ua-mobile: ?1',
          'origin: https://stablediffusionweb.com',
          'x-requested-with: mark.via.gp',
          'sec-fetch-site: same-origin',
          'sec-fetch-mode: cors',
          'sec-fetch-dest: empty',
          'referer: https://stablediffusionweb.com/auth/otp?type=SIGNUP&redirectTo=%2Fapp&identifier=$email',
          'accept-language: en-US,en;q=0.9',
          'priority: u=1, i',
        ],
          ]);

          $response = curl_exec($curl);
          $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
          $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
          $headers = substr($response, 0, $header_size);
          $body = substr($response, $header_size);
          $err = curl_error($curl);

          curl_close($curl);

          if ($err || $http_code !== 200) {
              $message = "Error: " . ($err ?: $response);
          } else {
              // Extract new auth_session cookie and update JSON
              if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
                  $new_auth_session = $matches[1];
                  $data[$email]['cookie'] = $new_auth_session;
              }

               // Parse response and update user data
              $responseData = json_decode($body, true);
              if (isset($responseData[0]['result']['data']['json'])) {
                  $userData = $responseData[0]['result']['data']['json'];
                  $data[$email]['user'] = $userData['user'];
                  $data[$email]['sessionId'] = $userData['sessionId'];
                  $data[$email]['state'] = $userData['state'];
                  file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
                  $message =  "OTP Verified Successfully. User data and updated cookie saved.";
                  $showOtpForm = false;
                  $showSignupForm = false;
              } else {
                 $message = "Error verifying OTP: " . $response;
              }
            }
        }
    }
}


?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Signup and OTP Verification</title>
    <style>
        body {
            font-family: 'Arial', sans-serif;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            min-height: 100vh;
            margin: 0;
            background-color: #f4f4f4;
            color: #333;
        }

        h1 {
            color: #2c3e50;
            margin-bottom: 20px;
            text-align: center;
        }
        form {
            background-color: #fff;
            padding: 30px;
            border-radius: 8px;
            box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
            width: 300px;
            display: flex;
            flex-direction: column;
             align-items: center;
            transition: transform 0.3s ease-in-out;
            margin-bottom: 20px;
        }
        form:hover {
           transform: scale(1.02);
       }

        label {
            display: block;
            margin-bottom: 8px;
            color: #555;
        }

        input[type="email"],
        input[type="text"] {
            width: calc(100% - 22px);
            padding: 10px;
            margin-bottom: 20px;
            border: 1px solid #ddd;
            border-radius: 4px;
            box-sizing: border-box;
            transition: border-color 0.3s ease;
        }

         input[type="email"]:focus,
        input[type="text"]:focus {
            border-color: #3498db;
            outline: none;
        }
        button {
            background-color: #3498db;
            color: white;
            padding: 10px 15px;
            border: none;
            border-radius: 4px;
            cursor: pointer;
            transition: background-color 0.3s ease;
        }
        button:hover {
            background-color: #217dbb;
        }
        .message {
             text-align: center;
             color: #27ae60;
              margin-bottom: 20px;
               font-size: 1.1em;
        }

        .error {
             text-align: center;
             color: #e74c3c;
             margin-bottom: 20px;
             font-size: 1.1em;
        }

        .hidden {
            display: none;
        }
        
        .form-container {
          display: flex;
          flex-direction: column;
          align-items: center;

        }

          .form-slide-up {
          animation: slideUp 0.5s ease-out forwards;
        }
           @keyframes slideUp {
            from {
                transform: translateY(50px);
                opacity: 0;
            }
            to {
                transform: translateY(0);
                opacity: 1;
            }
        }

        
    </style>
</head>
<body>
    <div class="form-container">
    <?php if ($message): ?>
        <div class="<?php echo strpos($message, 'Error') !== false ? 'error' : 'message'; ?>"><?php echo $message; ?></div>
    <?php endif; ?>

    <?php if ($showSignupForm): ?>
      <form action="index.php" method="POST"  class="form-slide-up">
            <h1>Signup</h1>
            <input type="hidden" name="action" value="signup">
            <label for="email">Email:</label>
            <input type="email" id="email" name="email" value="<?php echo $email; ?>" required>
            <button type="submit">Signup</button>
        </form>
      <?php endif; ?>

      <?php if ($showOtpForm): ?>
        <form action="index.php" method="POST"  class="form-slide-up">
            <h1>Verify OTP</h1>
            <input type="hidden" name="action" value="otpverify">
             <label for="email">Email:</label>
            <input type="email" id="email" name="email"  value="<?php echo $email; ?>" required>
            <label for="otp">OTP:</label>
            <input type="text" id="otp" name="otp" required>
            <button type="submit">Verify</button>
        </form>
      <?php endif; ?>
      </div>

    <script>
         // Store email in local storage
        const emailInput = document.querySelector('input[name="email"]');
        if (emailInput) {
            emailInput.addEventListener('input', () => {
                localStorage.setItem('signupEmail', emailInput.value);
            });
        }

         // Check and set stored email in form
         document.addEventListener('DOMContentLoaded', () => {
            const storedEmail = localStorage.getItem('signupEmail');
            if (storedEmail && emailInput) {
                emailInput.value = storedEmail;
            }
        });
    </script>
</body>
</html>