<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Manage APIs</title>
</head>
<body>
    <h1>Manage APIs</h1>

    <?php
    // Define a secret password
    $secret_password = "2627";

    // Path to the JSON file
    $jsonFile = 'APIs.json';

    // Function to load JSON data
    function loadJsonData($jsonFile) {
        if (file_exists($jsonFile)) {
            $jsonData = file_get_contents($jsonFile);
            return json_decode($jsonData, true);
        } else {
            echo "<p>Error: JSON file not found.</p>";
            return null;
        }
    }

    // Check if the form to delete an API was submitted
    if (isset($_POST['delete_api'])) {
        $password = $_POST['password'];
        $apiToDelete = $_POST['api_to_delete'];

        // Validate the password
        if ($password === $secret_password) {
            $data = loadJsonData($jsonFile);

            if ($data) {
                // Remove the selected API from the list
                foreach ($data['apis'] as $key => $api) {
                    if ($api['name'] === $apiToDelete) {
                        unset($data['apis'][$key]);
                        $data['apis'] = array_values($data['apis']); // Re-index the array
                        file_put_contents($jsonFile, json_encode($data, JSON_PRETTY_PRINT));
                        echo "<p>API '$apiToDelete' has been successfully deleted.</p>";
                        break;
                    }
                }
            }
        } else {
            echo "<p>Invalid password. You are not authorized to delete an API.</p>";
        }
    }

    // Show all existing APIs and delete option
    if (isset($_POST['show_apis']) || isset($_POST['delete_api'])) {
        $password = $_POST['password'];

        // Validate the password to show or delete APIs
        if ($password === $secret_password) {
            $data = loadJsonData($jsonFile);

            if ($data) {
                echo "<h2>Existing APIs</h2>";
                echo "<ul>";
                foreach ($data['apis'] as $api) {
                    echo "<li><strong>{$api['name']}</strong> - {$api['xi-api-key']} 
                    <form method='POST' style='display:inline'>
                        <input type='hidden' name='password' value='$password'>
                        <input type='hidden' name='api_to_delete' value='{$api['name']}'>
                        <input type='submit' name='delete_api' value='Delete'>
                    </form></li>";
                }
                echo "</ul>";
            }
        } else {
            echo "<p>Invalid password. You are not authorized to view or delete APIs.</p>";
        }
    }
    ?>

    <!-- Form to add new API -->
    <h2>Add a New API</h2>
    <form method="POST">
        <label for="name">API Name:</label>
        <input type="text" id="name" name="name" required><br><br>

        <label for="api_key">API Key:</label>
        <input type="text" id="api_key" name="api_key" required><br><br>

        <label for="password">Password:</label>
        <input type="password" id="password" name="password" required><br><br>

        <input type="submit" value="Add API">
    </form>

    <?php
    // Check if the form to add a new API was submitted
    if ($_SERVER['REQUEST_METHOD'] === 'POST' && !isset($_POST['delete_api']) && !isset($_POST['show_apis'])) {
        $name = $_POST['name'];
        $apiKey = $_POST['api_key'];
        $password = $_POST['password'];

        // Validate the password
        if ($password === $secret_password) {
            $data = loadJsonData($jsonFile);

            if ($data) {
                // Add the new API to the 'apis' array
                $newApi = [
                    "name" => $name,
                    "xi-api-key" => $apiKey
                ];
                $data['apis'][] = $newApi;

                // Encode and write updated data back to the JSON file
                file_put_contents($jsonFile, json_encode($data, JSON_PRETTY_PRINT));
                echo "<p>New API has been successfully added!</p>";
          
 $voiceID = 'pGmf9n00N8tgWVDhbQAY';
$url = "https://api.elevenlabs.io/v1/voices/add/20fd2d803be06a425d7b6392de589393921b8f62bfa400e433a2a96ce5dd4aa1/$voiceID";

// Set up the data to be sent in JSON format
$data = [
    "new_name" => "Neal"
];

// Initialize cURL session
$ch = curl_init($url);

// Set cURL options
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  // Return response instead of outputting it
curl_setopt($ch, CURLOPT_POST, true);  // This is a POST request
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    "User-Agent: Mozilla/5.0",
    "Content-Type: application/json",
    "xi-api-key: $apiKey"  // Set the API key
]);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));  // Convert data to JSON

// Execute the request
$response = curl_exec($ch);

// Check for errors
if (curl_errno($ch)) {
    echo "Error: " . curl_error($ch);
} else {
    // Output the response
    echo "Neal voice added Successfully: " . $response;
}

// Close the cURL session
curl_close($ch);        
          
          
          
          
          
            }
        } else {
            echo "<p>Invalid password. You are not authorized to add a new entry.</p>";
        }
    }
    ?>

    <!-- Form to show existing APIs -->
    <h2>Show Existing APIs</h2>
    <form method="POST">
        <label for="password">Password:</label>
        <input type="password" id="password" name="password" required><br><br>
        <input type="submit" name="show_apis" value="Show APIs">
    </form>

</body>
</html>
