<?php

// Function to load JSON data
function loadJsonData($jsonFile) {
    if (file_exists($jsonFile)) {
        $jsonData = file_get_contents($jsonFile);
        return json_decode($jsonData, true);
    } else {
        return ['apis' => []]; // Return an empty apis array if the file doesn't exist
    }
}

// Function to save JSON data
function saveJsonData($jsonFile, $data) {
    file_put_contents($jsonFile, json_encode($data, JSON_PRETTY_PRINT));
}

$apiJsonFile = 'APIs.json';
$expiredApiJsonFile = 'ExpiredAPIs.json';
$apiData = loadJsonData($apiJsonFile);
$expiredApiData = loadJsonData($expiredApiJsonFile);

// Handle POST request to update quota_exceeded status
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['flaggedKeys'])) {
    $flaggedKeys = json_decode($_POST['flaggedKeys'], true);

    if (isset($apiData['apis']) && is_array($apiData['apis'])) {
        $newApiData = ['apis' => []];
        $expiredApisToAdd = [];

        foreach ($apiData['apis'] as $api) {
            if (in_array($api['name'], $flaggedKeys)) {
                // Move the API to expired APIs
                $api['quota_exceeded'] = true;
               $expiredApisToAdd[] = $api;
            } else {
                 $api['quota_exceeded'] = false;
                // Keep the API in the main list
                $newApiData['apis'][] = $api;
            }
        }
        $apiData = $newApiData;

        if(!empty($expiredApisToAdd)){
            if(isset($expiredApiData['apis']) && is_array($expiredApiData['apis'])){
                $expiredApiData['apis'] = array_merge($expiredApiData['apis'], $expiredApisToAdd);
            }else{
                $expiredApiData['apis'] =  $expiredApisToAdd;
            }
        }

        // Save the modified data back to files
        saveJsonData($apiJsonFile, $apiData);
        saveJsonData($expiredApiJsonFile, $expiredApiData);
    }
}
?>