<?php

// Function to load JSON data
function loadJsonData($jsonFile) {
    if (file_exists($jsonFile)) {
        $jsonData = file_get_contents($jsonFile);
        return json_decode($jsonData, true);
    } else {
        return ['apis' => []]; // Return an empty apis array if the file doesn't exist
    }
}

// Function to save JSON data
function saveJsonData($jsonFile, $data) {
    file_put_contents($jsonFile, json_encode($data, JSON_PRETTY_PRINT));
}

$apiJsonFile = 'APIs.json';
$expiredApiJsonFile = 'ExpiredAPIs.json';
$apiData = loadJsonData($apiJsonFile);
$expiredApiData = loadJsonData($expiredApiJsonFile);

// Handle POST request to update quota_exceeded status
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['flaggedKeys'])) {
     $flaggedKeys = json_decode($_POST['flaggedKeys'], true);


    if (isset($expiredApiData['apis']) && is_array($expiredApiData['apis'])) {
         $newExpiredApiData = ['apis' => []];
         $activeApisToAdd = [];

        foreach ($expiredApiData['apis'] as $api) {
             if (in_array($api['name'], $flaggedKeys)) {
                   // Move the API to active APIs
                $api['quota_exceeded'] = false;
                $activeApisToAdd[] = $api;

           } else {
                // Keep the API in the expired list
                 $api['quota_exceeded'] = true;
                $newExpiredApiData['apis'][] = $api;
            }
        }

        $expiredApiData = $newExpiredApiData;

          if(!empty($activeApisToAdd)){
              if(isset($apiData['apis']) && is_array($apiData['apis'])){
                   $apiCount = count($apiData['apis']);
                   foreach($activeApisToAdd as $index => $api){
                        $api['name'] = 'Key' . ($apiCount + $index + 1);
                     $apiData['apis'][] = $api;
                   }
             }else{
                 $apiData['apis'] =  $activeApisToAdd;
             }
        }
        // Save the modified data back to files
          saveJsonData($apiJsonFile, $apiData);
          saveJsonData($expiredApiJsonFile, $expiredApiData);

    }
}
?>