<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>PDF Viewer with Proxy Download and File Size</title>
<link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.7/css/bootstrap.min.css'>
<link rel='stylesheet' href='//netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css'><link rel="stylesheet" href="./style.css">
<style>
body {
padding: 10px;
font-family: Arial, sans-serif;
background-color: #f7fafc;
color: #333;
}

button {
    width: 100%;
    padding: 15px;
    font-size: 20px;
    font-weight: 1000;
    color: white;
    background-color: #E94E77;
    border: none;
    border-radius: 8px;
    box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
    cursor: pointer;
    transition: background-color 0.3s ease, transform 0.2s ease;
    margin: 2px;
}

button:hover {
    background-color: #D4426B;
    transform: translateY(-3px);
}

.btn {
    display: block;
    margin: 0 auto 20px;
    padding: 15px 40px;
    font-size: 20px;
    color: white;
    background: linear-gradient(-45deg, #ee7752, #e73c7e, #23a6d5, #23d5ab);
    background-size: 400% 400%;
    border: none;
    border-radius: 30px;
    cursor: pointer;
    text-align: center;
    animation: gradientBackground 8s ease infinite;
    box-shadow: 0 6px 12px rgba(0, 0, 0, 0.1);
    font-weight: bold;
    white-space: normal; /* Allows text to wrap */
    word-break: break-word; /* Breaks long words */
    overflow-wrap: break-word; /* Ensures text fits within the button */
}


/* Gradient Animation */
@keyframes gradientBackground {
0% {
background-position: 0% 50%;
}
50% {
background-position: 100% 50%;
}
100% {
background-position: 0% 50%;
}
}
.btn .btn-download {
display: flex;
align-items: center;
justify-content: space-between;
}
.btn .btn-download > span {
margin: 5px;
}
.btn .icon-file-text-alt, .btn .icon-cloud-download {
font-size: 24px;
}
iframe {
width: 100%;
height: 90vh;
border: 2px solid #E94E77;
border-radius: 5px;
}
</style>
</head>
<body>
<div style="text-align: center; margin-top: 20px;">
        <button onclick="window.history.back()">🔙 Go Back</button>
    </div>  
<?php
if (isset($_GET['pdfurl'])) {
$pdfUrl = base64_decode($_GET['pdfurl']);
$fileName = isset($_GET['title']) ? base64_decode($_GET['title']) . '.pdf' : 'download.pdf';
$title = base64_decode($_GET['title']);
// Function to format file sizes (bytes to KB, MB, etc.)
function formatSizeUnits($bytes) {
if ($bytes >= 1073741824) {
$bytes = number_format($bytes / 1073741824, 2) . ' GB';
} elseif ($bytes >= 1048576) {
$bytes = number_format($bytes / 1048576, 2) . ' MB';
} elseif ($bytes >= 1024) {
$bytes = number_format($bytes / 1024, 2) . ' KB';
} elseif ($bytes > 1) {
$bytes = $bytes . ' bytes';
} elseif ($bytes == 1) {
$bytes = $bytes . ' byte';
} else {
$bytes = '0 bytes';
}
return $bytes;
}
// Function to get the file size using cURL
function getFileSize($url) {
$ch = curl_init($url);
curl_setopt($ch, CURLOPT_NOBODY, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HEADER, true);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
curl_setopt($ch, CURLOPT_MAXREDIRS, 3);
curl_exec($ch);
$fileSize = curl_getinfo($ch, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
curl_close($ch);
return $fileSize;
}
// Get file size in bytes and format it
$fileSizeBytes = getFileSize($pdfUrl);
$formattedFileSize = formatSizeUnits($fileSizeBytes);
// Function to download and proxy the file
function proxyFileDownload($url, $customFileName) {
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
curl_setopt($ch, CURLOPT_HEADER, false);
// Execute cURL and get the file content
$fileData = curl_exec($ch);
if (curl_errno($ch)) {
die('Error: ' . curl_error($ch));
}
$contentType = curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
curl_close($ch);
if ($fileData !== false) {
header('Content-Description: File Transfer');
header('Content-Type: ' . $contentType);
header('Content-Disposition: attachment; filename="' . $customFileName . '"');
header('Content-Transfer-Encoding: binary');
header('Expires: 0');
header('Cache-Control: must-revalidate');
header('Pragma: public');
header('Content-Length: ' . strlen($fileData));
ob_clean();
flush();
echo $fileData;
exit;
} else {
echo "Failed to download file.";
}
}
if (isset($_GET['download'])) {
proxyFileDownload($pdfUrl, $fileName);
}

$pdfUrl2= base64_encode($pdfUrl);
$title2= base64_encode($title);

echo <<<HTML
<center>
<a class="btn" href="?pdfurl=$pdfUrl2&title=$title2&download=1" class="btn">
<span class="btn-download">
<span class="icon-file-text-alt pull-left"></span>
<span class="text-left">
$fileName<br/>
File Size: $formattedFileSize<br/>
Click here to Download
</span>
<span class="icon-cloud-download pull-right"></span>
</span>
</a>
</center>
HTML;
echo '<pdf-viewer src="' . $pdfUrl . '"></pdf-viewer>';
} else {
echo "<p>No PDF URL provided.</p>";
}
?>
<script>
const template = document.createElement('template');
template.innerHTML = `
<iframe frameborder="0"></iframe>
`;
class PdfViewer extends HTMLElement {
constructor() {
super();
const shadowRoot = this.attachShadow({ mode: 'open' });
shadowRoot.appendChild(template.content.cloneNode(true));
}
static get observedAttributes() {
return ['src'];
}
connectedCallback() {
this.updateIframeSrc();
}
attributeChangedCallback(name) {
if (name === 'src') {
this.updateIframeSrc();
}
}
updateIframeSrc() {
const iframe = this.shadowRoot.querySelector('iframe');
iframe.setAttribute(
'src',
`https://mozilla.github.io/pdf.js/legacy/web/viewer.html?file=${this.getAttribute('src') || ''}`
);
iframe.style.width = "100%";
iframe.style.height = "90vh";
}
}
customElements.define('pdf-viewer', PdfViewer);
</script>

<center>
<a href="https://hits.seeyoufarm.com"><img src="https://hits.seeyoufarm.com/api/count/incr/badge.svg?url=https://amar.eu.org&count_bg=%2379C83D&title_bg=%23555555&icon=&icon_color=%23E7E7E7&title=Page Views -&edge_flat=false" /></a>
<p>Made with
<span>&#9829;</span>
by- <span style="color:red"><a style="color:teal;text-decoration:none" href="https://amarkoiri.t.me">🦋⍣⃝𝐀𝐦𝐚𝐫𝕾𝖎𝖗🕊</a></span></p>
</center>


</body>
</html>
