<?php
//header("Content-Type:application/json");
$id=$_GET['id'];
$category_id=$_GET['category_id'];

$url = "https://www.selfstudys.com:8081/api/v9/gk/get-mock-test-by-min-id?id=$id&category_id=$category_id&app_version=90000060&application_id=letest.ncertbooks";

$headers = [
    "Authorization: nEnIi7cEFREJdh25EcPkA5snRxY=",
    "Host: www.selfstudys.com",
    "User-Agent: okhttp/3.12.0"
];

// Initialize cURL
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

// Execute cURL and get the response
$jsonData = curl_exec($ch);
curl_close($ch);
$data = json_decode($jsonData, true);

// Process the data to remove HTML tags and decode HTML entities
if ($data['status'] === 'success') {
    foreach ($data['data'] as &$item) {
        $item['option_question'] = $item['option_question'];
        $item['option_A'] = $item['option_A'];
        $item['option_B'] = $item['option_B'];
        $item['option_C'] = $item['option_C'];
        $item['option_D'] = $item['option_D'];
        $item['option_ans'] = $item['option_ans'];
    }
}

// Re-encode the cleaned data back to JSON
$cleanedJsonData = json_encode($data, JSON_UNESCAPED_UNICODE | JSON_PRETTY_PRINT);
?>

<!DOCTYPE html>
<html lang="en">
<head>
   <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Mock Test</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 20px;
        }
        .question-container {
            margin-bottom: 20px;
            border: 1px solid #ddd;
            padding: 10px;
            border-radius: 8px;
        }
        .question {
            font-weight: bold;
        }
        .option {
            margin: 5px 0;
        }
        .show-answers {
            display: none;
            color: green;
            font-weight: bold;
        }
        .correct-answer {
            color: blue;
        }
        .correct {
            background-color: #d4edda; /* Light green for correct answers */
        }
        .incorrect {
            background-color: #f8d7da; /* Light red for incorrect answers */
        }
        .not-attempted {
            background-color: #fff3cd; /* Light yellow for not attempted */
        }
        button {
            padding: 10px 15px;
            margin-top: 20px;
            font-size: 16px;
        }
    </style>
</head>
<body>

    <h1><?=$_GET['title']?></h1>
    <div id="questions-container"></div>
    <div id="result"></div>
    <button onclick="submitTest()">Submit Test</button>

    <script>
        // Replace this with your cleaned JSON data
        const apiResponse = <?=$cleanedJsonData?>; 

        const questionsContainer = document.getElementById('questions-container');

        function loadQuestions() {
            apiResponse.data.forEach((question, index) => {
                const questionDiv = document.createElement('div');
                questionDiv.classList.add('question-container');
                questionDiv.innerHTML = `
                    <div class="question">${index + 1}. ${question.option_question}</div>
                    <div class="option"><input type="radio" name="q${index}" value="A"> a) ${question.option_A}</div>
                    <div class="option"><input type="radio" name="q${index}" value="B"> b) ${question.option_B}</div>
                    <div class="option"><input type="radio" name="q${index}" value="C"> c) ${question.option_C}</div>
                    <div class="option"><input type="radio" name="q${index}" value="D"> d) ${question.option_D}</div>
                    <div class="show-answers correct-answer">Correct Answer: ${question.option_ans.replace(/<[^>]*>/g, '').toUpperCase()}</div>
                `;
                questionsContainer.appendChild(questionDiv);
            });
        }

        function submitTest() {
            const resultDiv = document.getElementById('result');
            let score = 0;
            let attempted = 0;
            let correct = 0;
            let incorrect = 0;

            apiResponse.data.forEach((question, index) => {
                const questionDiv = document.querySelector(`.question-container:nth-child(${index + 1})`);
                const selectedAnswer = document.querySelector(`input[name="q${index}"]:checked`);
                const correctAnswer = question.option_ans.replace(/<[^>]*>/g, '').trim().toUpperCase(); // Clean answer

                if (selectedAnswer) {
                    attempted++;
                    const selectedValue = selectedAnswer.value.trim().toUpperCase(); // Convert selected answer to uppercase

                    // Compare selected answer with correct answer
                    if (selectedValue === correctAnswer) {
                        score++;
                        correct++;
                        questionDiv.classList.add('correct'); // Add class for correct answers
                    } else {
                        incorrect++;
                        questionDiv.classList.add('incorrect'); // Add class for incorrect answers
                    }
                } else {
                    // If not selected, count it as not attempted
                    questionDiv.classList.add('not-attempted'); // Add class for not attempted
                    incorrect++;
                }

                // Show correct answers after submission
                document.querySelectorAll('.show-answers').forEach(el => el.style.display = 'block');
            });

            // Display the results
            resultDiv.innerHTML = `
                <h2>Your Results:</h2>
                <p>Total Questions: ${apiResponse.data.length}</p>
                <p>Attempted: ${attempted}</p>
                <p>Correct: ${correct}</p>
                <p>Incorrect: ${incorrect}</p>
                <p>Not Attempted: ${apiResponse.data.length - attempted}</p>
                <p>Your Score: ${score} / ${apiResponse.data.length}</p>
            `;
        }

        loadQuestions();
    </script>

</body>
</html>
