<div id="notifications" class="content active">
<center>
        <h1>Short News Feed<h1>
        <hr>
    </center>

<?php
// Cache file path
$cacheFile = 'cache.json';
$cacheTime = 86400; // 24 hours in seconds

// Check if cache file exists and is fresh
if (file_exists($cacheFile) && (time() - filemtime($cacheFile) < $cacheTime)) {
    // Load data from cache
    $data = json_decode(file_get_contents($cacheFile), true);
} else {
    // Fetch JSON data from API with headers
    $url = "https://www.selfstudys.com/api/v7/get-ncrt--daily-updates?max_content_id=0";
    $headers = [
        "Authorization: nEnIi7cEFREJdh25EcPkA5snRxY=",
        "Host: www.selfstudys.com",
        "User-Agent: okhttp/3.12.0"
    ];

    // Initialize cURL
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    // Execute cURL and get the response
    $jsonData = curl_exec($ch);
    curl_close($ch);   

    // Cache the JSON data
    file_put_contents($cacheFile, $jsonData);

    // Decode JSON
    $data = json_decode($jsonData, true);
}

// Function to clean up description by removing sponsored content
// Function to clean up description by removing sponsored content and converting PDF links
function cleanDescription($description) {
    // Use DOMDocument to parse and modify HTML content
    $dom = new DOMDocument();
    libxml_use_internal_errors(true); // Suppress errors for malformed HTML
    $dom->loadHTML($description);
    libxml_clear_errors();

    // Remove elements with rel="sponsored"
    $xpath = new DOMXPath($dom);
    foreach ($xpath->query('//a[@rel="sponsored"]') as $node) {
        $node->parentNode->removeChild($node); // Remove the entire <a> tag with rel="sponsored"
    }

    // Convert PDF links to pdfviewer.php?pdfurl= format
    foreach ($xpath->query('//a[contains(@href, ".pdf")]') as $pdfLink) {
        $pdfUrl = $pdfLink->getAttribute('href');
        $newUrl = 'pdfviewer.php?pdfurl=' . $pdfUrl;
        $pdfLink->setAttribute('href', $newUrl);
    }

    // Return the modified HTML
    return $dom->saveHTML();
}

// Check if 'category_id' is in the URL to display full content
if (isset($_GET['category_id'])) {
    $categoryId = $_GET['category_id'];

    // Find the item with the matching category_id
    $selectedItem = null;
    foreach ($data as $item) {
        if ($item['id'] == $categoryId) {
            $selectedItem = $item;
            break;
        }
    }

    if ($selectedItem) {
        // Clean the description to remove sponsored content
        $cleanedDescription = cleanDescription($selectedItem['description']);
        
        // Display the full content of the selected item
        echo "<h1>{$selectedItem['title']}</h1>";
        echo "<img src='https://www.selfstudys.com/uploads/images/{$selectedItem['image']}' alt='{$selectedItem['title']}' style='width:100%;'>";
        echo "<div>{$cleanedDescription}</div>";
        echo "<p>Updated at: {$selectedItem['updated_at']} -by 🦋⍣⃝𝐀𝐦𝐚𝐫𝕾𝖎𝖗🕊</p>";
    echo <<<h
    <div style="text-align: center; margin-top: 20px;">
        <button onclick="window.history.back()">🔙 Go Back</button>
    </div>
h;

    } else {
        echo "<p>No content found for the given category.</p>";
    }
} else {
    // Show the homepage with a list of card2s
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Home Page - JSON Data</title>
    <style>
        
        .card2 {
            background-color: #fff;
            border: 1px solid #ddd;
            border-radius: 8px;
          display:flex;
          flex-direction:column;
            margin: 0px;
            padding: 10px;
            width: 93%;
            text-decoration: none;
            color: #333;
            transition: background-color 0.3s ease;
        }
        .card2:hover {
            background-color: #f0f0f0;
        }
        .card2 img {
            width: 100%;
            border-radius: 10px;
            margin-bottom: 0px;
        }
        .card2 h2 {
            margin:0px;
            font-size: 18px;
        }
        .card2 .date {
            color: #666;
            font-size: 14px;
        }
        .load-more-btn {
            padding: 10px 20px;
            background-color: #2196F3;
            color: #fff;
            border: none;
            border-radius: 5px;
            cursor: pointer;
            margin-top: 5px;
        }
        .load-more-btn:hover {
            background-color: #1e88e5;
        }
    </style>
</head>
<body>

<div class="container2" id="card2-container2">
    <!-- Display initial 5 card2s -->
    <?php for ($i = 0; $i < 5 && $i < count($data); $i++) { ?>
        <a class="card2" href="?tab=notifications&category_id=<?php echo $data[$i]['id']; ?>">
            <h2><?php echo $data[$i]['title']; ?></h2>
            <img src="https://www.selfstudys.com/uploads/images/<?php echo $data[$i]['image']; ?>" alt="<?php echo $data[$i]['title']; ?>">
            <p class="date">Updated at: <?php echo $data[$i]['updated_at']; ?> -by 🦋⍣⃝𝐀𝐦𝐚𝐫𝕾𝖎𝖗🕊</p>
        </a>
    <?php } ?>
</div>

<!-- Load More button -->
<?php if (count($data) > 5) { ?>
<center>
    <button class="load-more-btn" id="loadMore">Load More</button>
</center>
<?php } ?>

<script>
// JavaScript to handle loading more data
let currentIndex = 5;
const data = <?php echo json_encode($data); ?>;

document.getElementById('loadMore').addEventListener('click', function() {
    let card2container2 = document.getElementById('card2-container2');

    // Load the next 5 items
    for (let i = currentIndex; i < currentIndex + 10 && i < data.length; i++) {
        let card2 = `
            <a class="card2" href="?tab=notifications&category_id=${data[i]['id']}">
                <h2>${data[i]['title']}</h2>
                <img src="https://www.selfstudys.com/uploads/images/${data[i]['image']}" alt="${data[i]['title']}">
                <p class="date">Updated at: ${data[i]['updated_at']} -by 🦋⍣⃝𝐀𝐦𝐚𝐫𝕾𝖎𝖗🕊</p>
            </a>
        `;
        card2container2.insertAdjacentHTML('beforeend', card2);
    }

    currentIndex += 5;

    // If all data has been loaded, hide the button
    if (currentIndex >= data.length) {
        document.getElementById('loadMore').style.display = 'none';
    }
});
</script>

</body>
</html>

<?php
}
?>





</div>
