<?php
// Function to fetch data using cURL
function fetchQuotes($maxContentId) {
    $url = "https://www.selfstudys.com/api/v7/v1/android/translator/get-next-content-by-cat-id?id=9&max_content_id=" . $maxContentId;
    $headers = [
        "Authorization: nEnIi7cEFREJdh25EcPkA5snRxY=",
        "Host: www.selfstudys.com",
        "User-Agent: okhttp/3.12.0"
    ];

    // Initialize cURL
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    // Execute cURL and get the response
    $jsonData = curl_exec($ch);
    curl_close($ch);

    return json_decode($jsonData, true);
}

// Handle Load More request
$maxContentId = isset($_GET['max_content_id']) ? $_GET['max_content_id'] : 999999999;
$quotes = fetchQuotes($maxContentId);
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Quotes</title>
    <style>
        
        .quote-box {
            background-color: #fff;
            border-radius: 8px;
            box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
            margin-bottom: 20px;
            padding: 20px;
            text-align: center;
        }
        .quote-title {
            font-size: 20px;
            font-weight: bold;
            margin-bottom: 10px;
        }
        .quote-content {
            font-size: 16px;
            margin-bottom: 10px;
        }
        .quote-author {
            font-size: 14px;
            color: #555;
        }
        #load-more {
            display: block;
            width: 100%;
            padding: 10px;
            background-color: #007BFF;
            color: white;
            border: none;
            cursor: pointer;
            text-align: center;
            border-radius: 8px;
            margin-top: 20px;
        }
    </style>
</head>
<body>

    <h1>Daily Quotes</h1>
    <div id="quotes-container">
        <?php if (!empty($quotes)): ?>
            <?php foreach ($quotes as $quote): ?>
                <div class="quote-box">
                    <div class="quote-title"><?php echo htmlspecialchars($quote['title']); ?></div>
                    <div class="quote-content"><?php echo $quote['option_question']; ?></div>
                    <div class="quote-content"><?php echo $quote['option_A']; ?></div>
                </div>
            <?php endforeach; ?>
        <?php else: ?>
            <p>No more quotes available.</p>
        <?php endif; ?>
    </div>

    <?php if (!empty($quotes)): ?>
        <a href="?tab=quotes&max_content_id=<?php echo end($quotes)['id']; ?>" id="load-more">Load More Quotes</a>
    <?php endif; ?>

</body>
</html>
