<?php
// URL to send the GET request
$url = 'https://tts-api.imyfone.com/v3/user/tourist_id';

// Generate a random device ID
function generateDeviceId() {
    return bin2hex(random_bytes(16)); // Generates a random 32-character hexadecimal string
}

$device_id = generateDeviceId();

// Set up headers
$headers = [
    'Origin: https',
    'X-Requested-With: TTS',
    'Accept: application/json, text/plain, */*',
    "Device: $device_id",
    'Connection: keep-alive',
    'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/116.0.0.0 Safari/537.36',
    'Referer: https',
    'Sec-Fetch-Site: cross-site',
    'Sec-Fetch-Dest: empty',
    'Host: tts-api.imyfone.com',
    'Accept-Encoding: gzip, deflate, br, zstd',
    'Sec-Fetch-Mode: cors',
    'sec-ch-ua: "Android WebView";v="129", "Not=A?Brand";v="8", "Chromium";v="129"',
    'sec-ch-ua-mobile: ?1',
    'sec-ch-ua-platform: "Android"',
    'Web-Req: 1',
    'Accept-Language: en-IN,en-US;q=0.9,en;q=0.8'
];

// Initialize cURL session
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
curl_setopt($ch, CURLOPT_HEADER, true); // Include headers in the output

// Execute the request
$response = curl_exec($ch);

// Separate headers and body
$header_size = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
$header = substr($response, 0, $header_size);
$body = substr($response, $header_size);

// Close the cURL session
curl_close($ch);

// Extract 'Set-Cookie' headers
preg_match_all('/^Set-Cookie:\s*([^;]*)/mi', $header, $cookies);
$set_cookies = implode('; ', $cookies[1]);

// Decode the JSON response body
$json_data = json_decode($body, true);

// Extract session_id and tourist_id
$session_id = $json_data['data']['session_id'] ?? null;
$tourist_id = $json_data['data']['tourist_id'] ?? null;

// Print the results
echo "Set-Cookie Header: $set_cookies\n";
echo "Session ID: $session_id\n";
echo "Tourist ID: $tourist_id\n";
?>