<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Text to Speech</title>
    <link rel="stylesheet" href="style.css" data-precedence="next"/>
</head>
<body>
    <h2>Text to Mr Beast Voice Converter</h2>
    <form method="POST" id="text-form">
        <textarea id="text-input" name="text-input" rows="5" placeholder="Enter your text here..."></textarea>
        <div id="text-stats"></div>
        <button type="submit">Convert to Speech</button>
    </form>
    <div id="audio-container"></div>
    <div id="log-box"></div>
    <div class="select-container">
        <div id="progress">Progress: 0%</div>
        <div id="elapsed-time">Elapsed Time: 0s</div>
        <div id="progress-bar"><div id="progress-bar-inner"></div></div>
    </div>
    <br><br><br><br><br><br>

    <script>
    // Reference to the textarea and text stats container
    const textArea = document.getElementById("text-input");
    const textStats = document.getElementById("text-stats");

    // Text stats calculation
    textArea.addEventListener("input", updateTextStats);
    function updateTextStats() {
        const text = textArea.value;
        const charCount = text.length;
        const wordCount = text.trim().split(/\s+/).filter(Boolean).length;
        const paragraphCount = text.split(/\n\s*\n/).filter(Boolean).length;

        textStats.textContent = `Characters: ${charCount} | Words: ${wordCount} | Paragraphs: ${paragraphCount}`;
    }

    // Additional JavaScript functions like splitTextIntoChunks and updateLogBox can be retained as they are.

    </script>

    <?php
    if ($_SERVER["REQUEST_METHOD"] == "POST") {
        $textInput = $_POST['text-input'];

        if (empty($textInput)) {
            echo "<script>document.getElementById('log-box').innerHTML += '<p style=\"color:red;\">Please enter some text.</p>';</script>";
        } else {
            echo "<script>
                (async () => {
                    const chunks = splitTextIntoChunks('$textInput');
                    const audioBlobs = [];
                    const maxRetries = 200;
                    let completedChunks = 0;

                    for (let i = 0; i < chunks.length; i += 5) {
                        const currentBatch = chunks.slice(i, i + 5);
                        const promises = currentBatch.map((chunk, index) => sendChunk(chunk, i + index));
                        await Promise.all(promises);
                    }

                    const mergedBlob = new Blob(audioBlobs.filter(blob => blob !== null), { type: 'audio/mpeg' });
                    const audioUrl = URL.createObjectURL(mergedBlob);
                    document.getElementById('audio-container').innerHTML = '<audio id=\"generated-audio\" controls><source src=\"' + audioUrl + '\" type=\"audio/mpeg\">Your browser does not support the audio element.</audio><a href=\"' + audioUrl + '\" download=\"speech-' + Date.now() + '.mp3\">Download Audio</a>';
                    document.getElementById('generated-audio').play();
                })();
            </script>";
        }
    }
    ?>

</body>
</html>
