<?php

$uploadDir = 'uploads'; // Directory to store files
if (!is_dir($uploadDir)) {
    mkdir($uploadDir, 0777, true);
}


// Read the list of files
$files = [];
if (is_dir($uploadDir)) {
    $filelist = glob($uploadDir . '/*.txt');
    if($filelist){
        foreach ($filelist as $file) {
            $files[] = basename($file);
        }
    }
}

?>


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Text to Speech</title>
    <link rel="stylesheet" href="style.css?id=1.7" data-precedence="next"/>
</head>
<body>
<input id="title-input" type="text" placeholder="Enter file name (optional)" style="width: 80%; margin-bottom: 10px; border-radius:10px;padding: 5px; font-size: 14px;box-shadow: inset 9px 9px 16px #bebebe, inset -9px -9px 16px #ffffff;border: 1px solid black;">

<button id="save-text-btn" onclick="saveText()" style="color: blue; text-decoration: none;">
Save Script to Server</button>
<button id="remove-newlines-button" onclick="removeNewlines()">Remove New Lines</button>
<textarea id="text-input" rows="20" placeholder="Enter your text here..."></textarea>
<div id="text-stats"></div>

<!-- Wrap the two select elements in a flexbox container -->
<div class="select-container">

<label for="api-select">API:</label>
<select id="api-select">
<option value="">Select Api</option>
<option value="">Worker</option>
<option value="">Legacy Voices</option>
</select>

<label for="narrator-select">Voice:</label>
<select id="narrator-select" class="form-control">
<option value="nPczCjzI2devNBz1zQrb">Brian-Hindi</option>
<option value="pqHfZKP75CvOlQylNhV4">Bill-English</option>

</select>


</div>


<button onclick="confirmConversion()">Convert to Speech</button>
<div id="audio-container"></div>
<div id="elapsed-time">Time Taken: 0s</div><div id="progress">Progress: 0%</div>
<div id="log-box"></div>


<div id="progress-bar">
<div id="progress-bar-inner">
</div>
</div>
<div id="ip">
            Your IP address is: 
            <?php
            // Fetch the IP address
            $ipAddress = $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];
            echo $ipAddress;
            ?>
</div>
<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('PaidTTS', '_blank', 'noopener,noreferrer')">
Paid tts Page</button>

<h2>Saved scripts:</h2>
    <ul id="fileList">
        <?php if (count($files) > 0) : ?>
            <?php foreach ($files as $file) : ?>
                <li>
                    <a href="text.php?file=<?php echo urlencode($file); ?>">
                        <?php echo htmlspecialchars($file); ?>
                    </a>
                </li>
            <?php endforeach; ?>
        <?php else : ?>
            <li>No files saved yet.</li>
        <?php endif; ?>
    </ul>

<script>

//save text to server

function saveText() {
        const filename = document.getElementById('title-input').value.trim();
        const content = document.getElementById('text-input').value;
            fetch('save_text.php', {
                method: 'POST',
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded',
                 },
                 body: `filename=${encodeURIComponent(filename)}&content=${encodeURIComponent(content)}`
           }).then(response => {
               if(response.ok) {
                     document.getElementById('title-input').value = '';
                     document.getElementById('text-input').value = '';
                   response.text().then(text =>{
                       alert(text);
                   });

                 } else {
                    return response.text().then(text => {
                       throw new Error(text || "Something went wrong!");
                      });
                }
             }).catch(err => {
                 console.log("Something went wrong!");
                console.error(err);
                 alert(err.message);
            });

    }

// Restore text and file name after a page refresh
        window.addEventListener('load', () => {
            const savedText = localStorage.getItem('text-input-free');
            const savedFileName = localStorage.getItem('title-input-free');
            if (savedText) document.getElementById('text-input').value = savedText;
            if (savedFileName) document.getElementById('title-input').value = savedFileName;
            
            loadApiStats(); // Load API stats on page load
        });

        // Save inputs to local storage
        document.getElementById('text-input').addEventListener('input', () => {
            localStorage.setItem('text-input-free', document.getElementById('text-input').value);
        });
        document.getElementById('title-input').addEventListener('input', () => {
            localStorage.setItem('title-input-free', document.getElementById('title-input').value);
        });


 // Reference to the textarea and text stats container
const textArea = document.getElementById("text-input");
const textStats = document.getElementById("text-stats");



function removeNewlines() {
        const textArea = document.getElementById('text-input');
        const text = textArea.value;
         const modifiedText = text.replace(/\n+/g, ' ').replace(/\s+/g, ' ').trim();
        textArea.value = modifiedText;
    }
// Text stats calculation
textArea.addEventListener("input", updateTextStats);
function updateTextStats() {
    const text = textArea.value;
    const charCount = text.length;
    const wordCount = text.trim().split(/\s+/).filter(Boolean).length; // Avoid counting empty strings as words
    const paragraphCount = text.split(/\n\s*\n/).filter(Boolean).length; // Avoid counting empty strings as paragraphs

    textStats.textContent = `Characters: ${charCount} | Words: ${wordCount} | Paragraphs: ${paragraphCount}`;
}   

function splitTextIntoChunks(text, chunkSize = 400) {
    const chunks = [];
    const paragraphs = text.split(/\n+/); // Split text into paragraphs

    paragraphs.forEach(paragraph => {

paragraph = paragraph.replace(/[*#\[\]\(\)]/g, ' ') // Remove * # and brackets
    .replace(/-{2,}/g, '') // Reduce two or more dashes to one
    .replace(/\s+/g, ' ') // Replace multiple spaces with one space
    .trim(); // Remove leading and trailing spaces

        if (paragraph.length === 0) return; // Skip if the paragraph is empty

        let start = 0;

        while (start < paragraph.length) {
            let end = start + chunkSize;

            if (end < paragraph.length) {
                // Find the last punctuation before the chunk ends
                let lastPunctuation = Math.max(
                    paragraph.lastIndexOf('.', end),
                    paragraph.lastIndexOf('!', end),
                    paragraph.lastIndexOf('?', end),
                    paragraph.lastIndexOf(',', end),
                    paragraph.lastIndexOf('।', end),
                    paragraph.lastIndexOf(':', end)
                );

                // Fallback to the last space if no punctuation or punctuation is too close to start
                if (lastPunctuation > start) {
                    end = lastPunctuation + 1; // Include punctuation
                } else {
                    let lastSpace = paragraph.lastIndexOf(' ', end);
                    if (lastSpace > start) {
                        end = lastSpace; // Fall back to the last space
                    }
                }
            }

            const chunk = paragraph.slice(start, end).trim();
            if (chunk.length > 0) {
                chunks.push(chunk); // Add the chunk only if it's not empty
            }
            start = end;
        }
    });

    return chunks;
}

// Added confirmation dialog
        function confirmConversion() {
            if (confirm("Are you sure you want to convert the text? This will clear the previous audio.")) {
                convertTextToSpeech();
            }
        }

// Initialize API Stats
const apiUrls = [
"https://nameless-shape-e4e0.cherry617.workers.dev/",  
"https://square-king-650a.amar185.workers.dev/",  
"https://black-moon-7e5d.cherry1.workers.dev/",  
"https://silent-meadow-7072.cherry2269.workers.dev/",  
"https://ancient-star-c75a.cherry805.workers.dev/",  
"https://holy-poetry-6051.cherry740.workers.dev/",  
"https://little-moon-5f5f.cherry403.workers.dev/",  
"https://winter-cloud-4ff2.cherry627.workers.dev/",  
"https://orange-cell-f9be.cherry228.workers.dev/",  
"https://wild-heart-a0ba.cherry539.workers.dev/",
"https://1.amarkoiri244.workers.dev/",
"https://1.amar423.workers.dev/",
"https://1.amarkoiri608.workers.dev/",
"https://1.amar465.workers.dev/",
"https://1.amar385.workers.dev/",
"https://1.worker1-54d.workers.dev/",
"https://1.amarkoiri963.workers.dev/",
"https://1.amarkoiri754.workers.dev/",
"https://1.amarkoiri687.workers.dev/",
"https://1.amarkoiri823.workers.dev/"
];


async function convertTextToSpeech() {
    const text = document.getElementById('text-input').value;
    const elapsedTimeDisplay = document.getElementById('elapsed-time');
  const titleInput = document.getElementById('title-input').value.trim();

const narratorSelect = document.getElementById('narrator-select');
    const narratorId = narratorSelect.value;
    const voiceName = document.getElementById('narrator-select').options[
        document.getElementById('narrator-select').selectedIndex
    ].textContent.split('-')[0].trim(); // Get the selected voice name
    

    const audioContainer = document.getElementById('audio-container');
    const logBox = document.getElementById('log-box');
    const progressIndicator = document.getElementById('progress');
    const progressBar = document.getElementById('progress-bar-inner');

    logBox.innerHTML = '';
    audioContainer.innerHTML = '';
    elapsedTimeDisplay.textContent = 'Time Taken: 0s';

    if (text.length === 0) {
        await fetchUsage();
        return;
    }



    const startTime = Date.now();
    let timerInterval;
    const MaleVoices = ["nPczCjzI2devNBz1zQrb", "pqHfZKP75CvOlQylNhV4", "bIHbv24MWmeRgasZH58o"];
    let voiceIndex = 0;

    function startTimer() {
        timerInterval = setInterval(() => {
             // Calculate elapsed time in seconds
            const elapsedTimeInSeconds = (Date.now() - startTime) / 1000;

            // Convert to hours, minutes, and seconds
            const hours = Math.floor(elapsedTimeInSeconds / 3600);
            const minutes = Math.floor((elapsedTimeInSeconds % 3600) / 60);
            const seconds = Math.floor(elapsedTimeInSeconds % 60);

            // Format the time string
            const formattedTime = `${hours.toString().padStart(2, '0')}h:${minutes.toString().padStart(2, '0')}m:${seconds.toString().padStart(2, '0')}s`;

            // Display the formatted time
            elapsedTimeDisplay.textContent = `Time Taken: ${formattedTime}`;
        }, 1000);
    }

    function stopTimer() {
        clearInterval(timerInterval);
    }

    startTimer();
    const chunks = splitTextIntoChunks(text, 400);
    const audioBlobs = Array(chunks.length).fill(null); // Array to store audio blobs in the correct order
    const maxRetries = 1000;
    let completedChunks = 0; // Track completed chunks for progress

    // Function to send one chunk with retry logic
    async function sendChunk(chunk, index) {
        let success = false;
        let retries = 0;
        let apiIndex = index % apiUrls.length; // Start with the current API index
        let currentApiUrl = apiUrls[apiIndex];
        while (!success && retries < maxRetries) {
           
            const apiUrl = apiUrls[apiIndex]; // Get the current API
            const randomValue2 = Math.random().toString(36).substring(7);
            let currentVoice = narratorId === "random1" ? MaleVoices[voiceIndex] : narratorId;
            if (narratorId === "random1") voiceIndex = (voiceIndex + 1) % MaleVoices.length;

            updateLogBox(`<p>Sending chunk no ${index + 1} \n ${chunk}\nusing API URL: ${apiUrl}. Retry count: ${retries}</p>`);
            logBox.scrollTop = logBox.scrollHeight;

            try {
                const response = await fetch(apiUrl + "?v=" + randomValue2, {
                    method: 'POST',
                    headers: { 'Content-Type': 'application/json' },
                    body: JSON.stringify({ text: chunk, narratorId: currentVoice })
                });

                if (response.ok && response.headers.get("Content-Type").includes("audio")) {
                    const blob = await response.blob();
                    audioBlobs[index] = blob; // Store blob at the correct index
                    success = true;
                    completedChunks++; // Increment completed chunk count
                    // Update progress
                    const progressPercentage = Math.round((completedChunks / chunks.length) * 100);
                    progressIndicator.textContent = `Progress: ${progressPercentage}%`;
                    progressBar.style.width = `${progressPercentage}%`;
                } else {
                    retries++;
                    apiIndex = (apiIndex + 1) % apiUrls.length; // Move to the next API for retry
                     currentApiUrl=apiUrls[apiIndex];
                    const errorData = await response.json();
                    updateLogBox(`<p style="color:red;">Error on chunk ${index + 1}: ${errorData.detail.status}. Retry ${retries}/${maxRetries}...</p>`);
                }
            } catch (error) {
                retries++;
                 apiIndex = (apiIndex + 1) % apiUrls.length; // Move to the next API for retry
                 currentApiUrl=apiUrls[apiIndex];
                updateLogBox(`<p style="color:red;">Network error on chunk ${index + 1}: ${error.message}. Retry ${retries}/${maxRetries}...</p>`);
            }
        }

        if (!success) {
            updateLogBox(`<p style="color:red;">Failed to convert chunk ${index + 1} after ${maxRetries} attempts.</p>`);
        }
    }

    // Main loop to send chunks in batches of 5
    for (let i = 0; i < chunks.length; i += 10) {
        const currentBatch = chunks.slice(i, i + 10); // Get the next 5 chunks
        const promises = currentBatch.map((chunk, index) => sendChunk(chunk, i + index));
        await Promise.all(promises); // Wait for the batch to complete before moving to the next
    }

    // Merge audio blobs into a single Blob, keeping the original order
    const mergedBlob = new Blob(audioBlobs.filter(blob => blob !== null), { type: 'audio/mpeg' });
    const audioUrl = URL.createObjectURL(mergedBlob);

const currentTime = new Date().toISOString().replace(/[:.]/g, '-');
const fileName = titleInput 
    ? `${titleInput}-${voiceName}-${currentTime}.mp3` 
    : `${voiceName}-${currentTime}.mp3`;


    audioContainer.innerHTML = `
        <audio id="generated-audio" controls>
            <source src="${audioUrl}" type="audio/mpeg">
            Your browser does not support the audio element.
        </audio>
        <a href="${audioUrl}" download="${fileName}">Download Audio</a>
    `;

    stopTimer();
    progressIndicator.textContent = 'Progress: 100% - Conversion Complete!';
    progressBar.style.width = '100%';
    updateLogBox('<p>Conversion complete!</p>');

    document.getElementById('generated-audio').play();
}

// Function to limit logs in the logBox
function updateLogBox(newLog) {
    const logBox = document.getElementById('log-box');
    logBox.innerHTML += newLog;
    const logs = logBox.getElementsByTagName('p');
    
    // Remove all but the last two logs
    while (logs.length > 50) {
        logBox.removeChild(logs[0]);
    }

    logBox.scrollTop = logBox.scrollHeight; // Ensure the latest log is visible
}

</script>

    
    
<script>
//legacy voice list function https://api.elevenlabs.io/v1/voices?show_legacy=true
async function fetchLegacyVoices() {

  try {
    const response = await fetch("https://api.elevenlabs.io/v1/voices?show_legacy=true", {
    });
    
    const data = await response.json();
    const voices = data.voices;
    
    populateVoiceSelect(voices);
  } catch (error) {
    console.error("Error fetching voices:", error);
    alert("An error occurred while fetching voices. Please try again.");
  }
}
// Function to populate the voice select dropdown
function populateVoiceSelect(voices) {
  const narratorSelect = document.getElementById('narrator-select');
  narratorSelect.innerHTML = ''; // Clear existing options

  voices.forEach((voice) => {
    const option = document.createElement('option');
    option.value = voice.voice_id;
    option.textContent = voice.name + "-"+voice.labels.gender+"-"+voice.labels.use_case;
    narratorSelect.appendChild(option);
  });
}
// Function to manually add values when "Worker" is selected
function populateWorkerVoices() {
  const workerVoices = [
    { voice_id: "nPczCjzI2devNBz1zQrb", name: "Brian" },
    { voice_id: "JBFqnCBsd6RMkjVDRZzb", name: "George" },
    { voice_id: "iP95p4xoKVk53GoZ742B", name: "Chris" },
    { voice_id: "onwK4e9ZLuTAKqWW03F9", name: "Daniel" },
    { voice_id: "pqHfZKP75CvOlQylNhV4", name: "Bill" },
    { voice_id: "bIHbv24MWmeRgasZH58o", name: "Will" },
    { voice_id: "pNInz6obpgDQGcFmaJgB", name: "Adam" },
    { voice_id: "flq6f7yk4E4fJM5XTYuZ", name: "Michael" },
    { voice_id: "cjVigY5qzO86Huf0OWal", name: "Eric" },
    { voice_id: "random1", name: "Random Males" }
  ];

  const narratorSelect = document.getElementById('narrator-select');
  narratorSelect.innerHTML = ''; // Clear existing options

  workerVoices.forEach((voice) => {
    const option = document.createElement('option');
    option.value = voice.voice_id;
    option.textContent = voice.name;
    narratorSelect.appendChild(option);
  });
}
// Event listener for API selection change
document.getElementById('api-select').addEventListener('change', async function() {
  const selectedApiName = this.options[this.selectedIndex].textContent;

  // If the selected API is "Worker", skip fetching
  if (selectedApiName === 'Worker') {
populateWorkerVoices();
    return;
  }

  // If the selected API is "Worker", skip fetching
  if (selectedApiName === 'Legacy Voices') {
await fetchLegacyVoices();
return;
  }
});
    </script>
</body>
</html>
