<?php

$directoryPath = "uploads";

if (!is_dir($directoryPath)) {
    // Directory doesn't exist, so create it
    mkdir($directoryPath, 0755, true);
}



?>





<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>File Upload</title>
    <style>
        body {
            background-color: #f0f0f0;
            display: block;
            align-items: center;            text-align: center;
            
            justify-content: center;
            height: 100vh;
            margin: 0;
            font-family: Arial, sans-serif;
        }

        h1 {
            text-align: center;
            text-transform: uppercase;
            letter-spacing: 2px;
            color: #333;
            margin-bottom: 30px;
            text-shadow: 1px 1px 1px rgba(0, 0, 0, 0.1);
        }

        form {
            background-color: #f0f0f0;
            padding: 20px;
            border-radius: 10px;
            box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.1), -5px -5px 15px rgba(255, 255, 255, 0.7);
        }

        label {
            display: block;
            margin-bottom: 10px;
        }

        input[type="file"] {
            padding: 10px;
            border: 1px solid #ddd;
            border-radius: 5px;
            margin-bottom: 10px;
            outline: none;
        }

        input[type="submit"] {
            background-color: #4CAF50;
            color: white;
            padding: 10px 15px;
            border: none;
            border-radius: 5px;
            cursor: pointer;
            transition: background-color 0.3s;
        }

        input[type="submit"]:hover {
            background-color: #45a049;
        }
    </style>
</head>
<body>
    <h1>Upload a File</h1>
    
   <?php
//set_time_limit(0);



$targetDir = "uploads/";
$targetFile = $targetDir . basename($_FILES["file"]["name"]);
$uploadOk = 1;
$imageFileType = strtolower(pathinfo($targetFile, PATHINFO_EXTENSION));



if ($uploadOk == 0) {
    echo "Sorry, your file was not uploaded.";
} else {
    if (move_uploaded_file($_FILES["file"]["tmp_name"], $targetFile)) {
        echo "The file " . basename($_FILES["file"]["name"]) . " has been uploaded.";
    } else {
        echo "Sorry, there was an error uploading your file.";
    }
}
?> 
    
    <form action="index.php" method="post" enctype="multipart/form-data">
        <label for="file">Choose a file:</label>
        <input type="file" name="file" id="file"><br>
        <input type="submit" value="Upload">
    </form>
</body>
</html>
<?php
$directory = 'uploads';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $fileToDelete = $_POST['delete_file'];
    
    // Perform necessary security checks for file deletion
    $filepathToDelete = "$directory/$fileToDelete";
    if (file_exists($filepathToDelete)) {
        unlink($filepathToDelete);
        echo "File deleted successfully.";
    } else {
        echo "File not found.";
    }
}

// Display files
$files = scandir($directory);
foreach ($files as $file) {
    if ($file != '.' && $file != '..') {
        echo "<p>$file - <a href='uploads/$file'>Download</a> | ";
        echo "<form method='post' style='display:inline;'>";
        echo "<input type='hidden' name='delete_file' value='$file'>";
        echo "<button type='submit'>Delete</button>";
        echo "</form></p>";
    }
}

if (isset($_GET['action']) && $_GET['action'] === 'download') {
    $fileToDownload = $_GET['file'];

    // Perform necessary security checks for file download
    $filepathToDownload = "$directory/$fileToDownload";
    if (file_exists($filepathToDownload)) {
        header("Content-disposition: attachment; filename=$fileToDownload");
       // readfile($filepathToDownload);
        exit();
    } else {
        echo "File not found.";
    }
}
?>
