<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>AudioBook Legends</title>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.6.0/css/all.min.css" integrity="sha512-Kc323vGBEqzTmouAECnVceyQqyqdsSiqLQISBL29aUW4U/M7pSPA/gEUZQqv1cwx4OnYxTxve5UMg5GT6L4JJg==" crossorigin="anonymous" referrerpolicy="no-referrer" />
<style>
body {
    font-family: Arial, sans-serif;
    margin: 0;
    padding: 0;
    background-color: #ecf0f3;
    display: flex;
    flex-direction: column;
    height: 100vh;
}

h1 {
    text-align: center;
    color: teal;
}

h2 {
    text-align: center;
    color: black;
}

.pdf-list {
    list-style: none;
    padding: 0;
}

.pdf-list li {
    margin: 10px 0;
    padding: 15px;
    background-color: #fff;
    border-radius: 8px;
    box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
    transition: transform 0.2s ease;
}

.pdf-list li:hover {
    transform: translateY(-3px);
}

a {
    text-decoration: none;
    color: #E94E77;
    font-weight: bold;
}

.message {
    color: red;
    text-align: center;
    margin: 20px 0;
}

.button-container {
    list-style: none;
    padding: 0;
}

.button-container form {
    margin: 10px 0;
}

button {
    width: 100%;
    padding: 15px;
    font-size: 20px;
    font-weight: 1000;
    color: white;
    background-color: #E94E77;
    border: none;
    border-radius: 8px;
    box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
    cursor: pointer;
    transition: background-color 0.3s ease, transform 0.2s ease;
    margin: 2px;
}

button:hover {
    background-color: #D4426B;
    transform: translateY(-3px);
}

@media (min-width: 768px) {
    .pdf-list li {
        margin: 15px 0;
    }

    button {
        width: 80%;
        margin: 0 auto;
    }
}

.content-container {
    flex-grow: 1;
    align-items: center;
    padding: 5px;
    margin: 10px;
    background-color: #ecf0f3;
    border-radius: 10px 10px 0 0; /* Curved top corners */
    box-shadow: 9px 9px 16px #d1d9e6, -9px -9px 16px #ffffff;
    transition: all 0.3s ease;
}

.content {
    display: none;
}

.content.active {
    display: block;
}

.menu {
    position: fixed;
    bottom: 0;
    width: 100%;
    display: flex;
    justify-content: space-around;
    background-color: #ecf0f3;
    padding: 10px 0;
    border-radius: 30px 30px 0 0; /* Curved top corners */
    box-shadow: 9px 9px 16px #d1d9e6, -9px -9px 16px #ffffff;
    transition: all 0.3s ease;
}

.menu-item {
    display: flex;
    flex-direction: column;
    align-items: center;
    cursor: pointer;
    padding: 10px;
    border-radius: 10px;
    background: #ecf0f3;
    box-shadow: inset 5px 5px 10px #bec8d2, inset -5px -5px 10px #ffffff;
    transition: all 0.3s ease;
}

.menu-item.active {
    background: #007bff; /* Highlight color for selected tab */
    color: white;
    box-shadow: 9px 9px 16px #0062cc, -9px -9px 16px #3399ff;
}

.menu-item i {
    font-size: 24px;
    color: #333;
    transition: color 0.3s ease;
}

.menu-item.active i {
    color: white;
}

.menu-item span {
    margin-top: 5px;
    font-size: 12px;
    color: #333;
}

.menu-item.active span {
    color: white;
}

.menu-item:hover {
    box-shadow: inset 5px 5px 10px #d1d9e6, inset -5px -5px 10px #ffffff;
}

.container {
    display: flex;
    flex-wrap: wrap;
    justify-content: center;
    margin-top: 5px;
    border-radius: 12px;
    border: 2px solid #008080;
}

.card {
    display: flex;
    align-items: center;
    width: 150px; /* Adjust width as needed */
    background-color: #FFFFFF;
    border: 2px solid #008080; /* Teal border */
    border-radius: 12px;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25), 0px 2px 2px rgba(0, 0, 0, 0.25), inset 0px -2px 2px rgba(0, 0, 0, 0.25);
    margin: 5px;
    padding: 10px;
    text-decoration: none;
    color: #333;
}

.card:hover {
    box-shadow: 0px 8px 8px rgba(0, 0, 0, 0.25), 0px 4px 4px rgba(0, 0, 0, 0.25), inset 0px -4px 4px rgba(0, 0, 0, 0.25);
    transform: translateY(-3px);
}

.card i {
    font-size: 40px; /* Increase the size of the icon */
    margin-right: 10px;
    color: #4285F4; /* Google Blue */
}

.card-icon {
    width: 40px; /* Adjust icon size */
    height: 40px;
    margin-right: 20px;
    border-radius: 50%; /* Optional: Add circular styling */
}

.card p {
    font-size: 15px;
    line-height: 1.2;
    font-weight: 600;
    flex-grow: 1; /* Allows the text to take up remaining space */
    margin: 0;
    text-align: left;
    white-space: normal; /* Allows text to wrap */
    word-break: break-word; /* Breaks long words */
    overflow-wrap: break-word;
}

.header {
    width: auto; /* Adjust width as needed */
    height: auto;
    background-color: #008080;
    color: #FFFFFF;
    padding: 0; /* Reduced padding */
    border-radius: 10px;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25), 0px 2px 2px rgba(0, 0, 0, 0.25), inset 0px -2px 2px rgba(0, 0, 0, 0.25);
    margin: 5px;
}

.search-bar {
    margin: 20px auto;
    display: flex;
    justify-content: center;
    align-items: center;
}

.search-bar input {
    padding: 10px;
    width: 80%;
    max-width: 500px;
    border: 2px solid #008080;
    border-radius: 12px;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25), 0px 2px 2px rgba(0, 0, 0, 0.25), inset 0px -2px 2px rgba(0, 0, 0, 0.25);
}

</style>
</head>
<body>
<div class="content-container">
<div id="home" class="content active">
<h1>Select a Audio Book Category</h1>
<div class='button-container'>
<div class='button'>
<a href='Cat.php?catId=100cc624-53cf-4c7d-950f-0235b413b47a'><button type='button'>New Books</button></a>
</div>


<div class='button'>
<a href='Cat.php?catId=73f1eea6-cbf9-4a5a-81b2-ff03a0dc17a4'><button type='button'>Career & Success</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=39915c56-484d-41ea-b57a-7661d6d5ce37'><button type='button'>Entrepreneurship</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=8f238f01-20eb-4fc1-b6b1-e9b2336489ec'><button type='button'>Money & Investments</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=cb25dd47-ee33-482b-a281-70f8af9151e8'><button type='button'>Corporate Culture</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=910d070f-e6b6-4965-99ba-b5561923cf86'><button type='button'>Education</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=7dd988d0-0a5a-41f5-831a-7d4fccc408e9'><button type='button'>Personal Development</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=2811e020-d678-43bf-9d6a-985ddcf065fc'><button type='button'>Health & Nutrition</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=769d8de5-3667-403a-ac68-79800b299731'><button type='button'>Management & Leadership</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=cc9e8706-f3fb-42b3-abcd-0c36748ed7cc'><button type='button'>Society & Culture</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=578165f5-8633-4489-adde-7327841fa2be'><button type='button'>Motivation & Inspiration</button></a>
</div>

<div class='button'>
<a href='Cat.php?catId=ef6e5a5a-e5b4-4cdf-876a-1df99356d414'><button type='button'>Mindfulness & Happiness</button></a>
</div>




    
</div>
    </div>
</div><br><br>  <br>  <br>  


</body>
</html>
