<?php

$dataFile = 'apis/cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];
$message = "";
$showOtpInput = false;
$email = "";

if (isset($_POST['action'])) {
    if ($_POST['action'] == 'signup') {
        $email = $_POST['email'];
        $password = $email; // Same as email
        $name = $email;

        $curl = curl_init();

        curl_setopt_array($curl, [
            CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.signup?batch=1',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_HEADER => true,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => '{"0":{"json":{"email":"' . $email . '","password":"' . $password . '","name":"' . $name . '","callbackUrl":"https://stablediffusionweb.com/auth/verify"}}}',
            CURLOPT_COOKIE => 'NEXT_LOCALE=en',
            CURLOPT_HTTPHEADER => [
                'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
                'Accept-Encoding: gzip, deflate, br, zstd',
                'Content-Type: application/json',
                'sec-ch-ua-platform: "Android"',
                'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
                'sec-ch-ua-mobile: ?1',
                'origin: https://stablediffusionweb.com',
                'x-requested-with: mark.via.gp',
                'sec-fetch-site: same-origin',
                'sec-fetch-mode: cors',
                'sec-fetch-dest: empty',
                'referer: https://stablediffusionweb.com/auth/signup',
                'accept-language: en-US,en;q=0.9',
                'priority: u=1, i',
            ],
        ]);

        $response = curl_exec($curl);
        $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
        $headers = substr($response, 0, $header_size);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err || $http_code !== 200) {
            $message = "Error: " . ($err ?: $response);
        } else {
            // Extract auth_session cookie
            if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
                $auth_session = $matches[1];
                $data[$email] = ['cookie' => $auth_session];
                file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
                $message = "Signup successful! Please verify OTP.";
                $showOtpInput = true;
            } else {
                $message = "No auth_session cookie found.";
            }

        }
    } else if ($_POST['action'] == 'otpverify') {
        $email = $_POST['email'];
        $otp = $_POST['otp'];

        if (!isset($data[$email])) {
            $message = "Error: No signup data found for this email.";
        } else {
            $auth_session = $data[$email]['cookie'];

            $postFields = '{"0":{"json":{"code":"' . $otp . '","type":"SIGNUP","identifier":"' . $email . '"}}}';

            $curl = curl_init();

            curl_setopt_array($curl, [
                CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.verifyOtp?batch=1',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_HEADER => true,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => $postFields,
                CURLOPT_COOKIE => 'NEXT_LOCALE=en; auth_session=' . $auth_session,
                CURLOPT_HTTPHEADER => [
                    'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
                    //   'Accept-Encoding: gzip, deflate, br, zstd',
                    'Content-Type: application/json',
                    'sec-ch-ua-platform: "Android"',
                    'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
                    'sec-ch-ua-mobile: ?1',
                    'origin: https://stablediffusionweb.com',
                    'x-requested-with: mark.via.gp',
                    'sec-fetch-site: same-origin',
                    'sec-fetch-mode: cors',
                    'sec-fetch-dest: empty',
                    'referer: https://stablediffusionweb.com/auth/otp?type=SIGNUP&redirectTo=%2Fapp&identifier=$email',
                    'accept-language: en-US,en;q=0.9',
                    'priority: u=1, i',
                ],
            ]);

            $response = curl_exec($curl);
            $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
            $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
            $headers = substr($response, 0, $header_size);
            $body = substr($response, $header_size);
            $err = curl_error($curl);

            curl_close($curl);

            if ($err || $http_code !== 200) {
                $message = "Error: " . ($err ?: $response);
            } else {
                // Extract new auth_session cookie and update JSON
                if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
                    $new_auth_session = $matches[1];
                    $data[$email]['cookie'] = $new_auth_session;
                }

                // Parse response and update user data
                $responseData = json_decode($body, true);
                if (isset($responseData[0]['result']['data']['json'])) {
                    $userData = $responseData[0]['result']['data']['json'];
                    $data[$email]['user'] = $userData['user'];
                    $data[$email]['sessionId'] = $userData['sessionId'];
                    $data[$email]['state'] = $userData['state'];
                    $data[$email]['activePeriodExpiresAt'] = $userData['activePeriodExpiresAt'];
                    $data[$email]['idlePeriodExpiresAt'] = $userData['idlePeriodExpiresAt'];
                    file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
                    $message =  "OTP Verified Successfully. User data and updated cookie saved.";
                    $showOtpInput = false;
                } else {
                    $message = "Error verifying OTP: " . $response;
                }
            }
        }
    }
}


?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>YouTube SEO Tool</title>
    <link rel="stylesheet" href="style.css?id=u3jhhe">
    <style>
        .image-list {
            display: flex;
            flex-wrap: wrap;
            gap: 10px;
            flex-direction: column-reverse; /* New images on top */
        }

        .image-list img {
            max-width: 200px; /* Adjust as needed */
            height: auto;
            border: 1px solid #ddd;
            padding: 5px;
        }
    </style>
</head>
<body>
<center>
    <div class="container">

        <h2>Book Mockup Generator</h2>
        <div id="email-selector">
            <select id="emailDropdown">
                <option value="">Select an Email</option>
                <?php
                if (!empty($data)) {
                    foreach ($data as $email2 => $value) {
                        echo "<option value='" . htmlspecialchars($email2) . "'>" . htmlspecialchars($email2) . "</option>";
                    }
                }
                ?>
            </select>
            <button onclick="loadContent()">Go</button>
        </div>
        <div id="content-container">
           <div id="user-details-container" class="user-details"></div>
            <form id="imageForm">
                  <div id="prompt-container">
                          <textarea style="         background-color: #f0f0f0;
              padding: 20px;
             border-radius: 15px;
               box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
             width: 100%;height:250px;
              max-width: 600px;
              flex-direction: column;
              align-items: center;
              transition: transform 0.3s ease-in-out;
               margin-bottom: 20px;
            box-sizing: border-box;
           text-align: center;
    "  id="prompt" placeholder="Enter your prompt here" maxlength="500">A hyper realistic, highly detailed image of an old book mockup titled "The Secret Mindset Of Successful People". The book mockup should be placed on a natural bokeh background. In the footer of the book cover, include the Author name "AudioBook Legends" with an old typography which is clearly visible, also add relevant elements from title in the book cover.</textarea>
                           <div id="prompt-counter">0 / 500</div>
                            <div id="prompt-warning">Character limit exceeded.</div>
                           </div>
                    <div class="dimension-options">
                        <label for="dimensionPreset">Select Image Dimension:</label>
                            <select id="dimensionPreset">
                                <option value="custom">Custom Input</option>
                                 <option value="book">Book Mockup 1:1</option>
                                  <option value="thumbnail">Thumbnail 16:9</option>
                            </select>
                    </div>
               <div class="dimensions" style="display: flex; justify-content: center; align-items: center; margin-bottom: 15px;">
    <label for="width" style="margin-right: 5px;">Width:</label>
    <input type="number" id="width" placeholder="Width" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
     <label for="height" style="margin-left: 5px; margin-right: 5px;">Height:</label>
    <input type="number" id="height" placeholder="Height" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
</div>
                 <!-- Number of Images Select -->
                <div class="image-number-options">
                    <label for="numImages">Number of Images:</label>
                    <select id="numImages">
                        <option value="1">1</option>
                        <option value="2">2</option>
                        <option value="3">3</option>
                        <option value="4">4</option>
                        <option value="5">5</option>
                    </select>
                </div>
                <button type="submit">Generate Image</button>
                <div id="status"></div>
            </form>
            <div id="image-container" class="image-list"></div>
            <div id="history-container"></div>
        </div>
    </div>
    <div class="form-container">
        <form action="index.php" method="POST" class="form-slide-up" id="signupForm">
            <h1>Add New Email</h1>
            <input type="hidden" name="action" value="signup">
            <label for="email">Email:</label>
            <input type="email" id="email" name="email" value="<?php echo $email; ?>" required>

            <?php if ($showOtpInput): ?>
                <label for="otp">OTP:</label>
                <input type="text" id="otp" name="otp" required>
                <input type="hidden" name="action" value="otpverify">
            <?php endif; ?>

            <button type="submit"><?php echo $showOtpInput ? 'Verify OTP' : 'Signup'; ?></button>
            <?php if ($message): ?>
                <div class="<?php echo strpos($message, 'Error') !== false ? 'error' : 'message'; ?>"><?php echo $message; ?></div>
            <?php endif; ?>
        </form>

    </div>
</center>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>


<script>
    let promptTextarea = null; // Declare promptTextarea outside loadContent
    let promptCounter = null;
    let promptWarning = null;
    let widthInput = null;
    let heightInput = null;
    let dimensionPresetDropdown = null;

    function updatePromptCounter() {
        if(!promptTextarea) return; // Check if textarea exists
        const currentLength = promptTextarea.value.length;
        promptCounter.textContent = currentLength + ' / 500';

        if (currentLength > 500) {
            promptWarning.style.display = 'block';
        } else {
            promptWarning.style.display = 'none';
        }
    }



    function updateDimensionInputs(preset) {
         if(!widthInput || !heightInput) return; // Check

        switch (preset) {
            case 'book':
                widthInput.value = 1024;
                heightInput.value = 1024;
                break;
            case 'thumbnail':
                widthInput.value = 1280;
                heightInput.value = 720;
                break;
            case 'custom':
                break;
        }
    }



    const contentContainer = document.getElementById('content-container');
    let currentEmail = null;

    function loadContent() {
        const emailDropdown = document.getElementById('emailDropdown');
        const selectedEmail = emailDropdown.value;
        if (!selectedEmail) return;
        currentEmail = selectedEmail;
        contentContainer.classList.add('show');
         contentContainer.innerHTML = `
            <div id="user-details-container" class="user-details"></div>
            <form id="imageForm">
                  <div id="prompt-container">
                          <textarea style="         background-color: #f0f0f0;
              padding: 20px;
             border-radius: 15px;
               box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
             width: 100%;height:250px;
              max-width: 600px;
              flex-direction: column;
              align-items: center;
              transition: transform 0.3s ease-in-out;
               margin-bottom: 20px;
            box-sizing: border-box;
           text-align: center;
    "  id="prompt" placeholder="Enter your prompt here" maxlength="500">A hyper realistic, highly detailed image of an old book mockup titled "The Secret Mindset Of Successful People". The book mockup should be placed on a natural bokeh background. In the footer of the book cover, include the Author name "AudioBook Legends" with an old typography which is clearly visible, also add relevant elements from title in the book cover.</textarea>
                           <div id="prompt-counter">0 / 500</div>
                            <div id="prompt-warning">Character limit exceeded.</div>
                           </div>
                    <div class="dimension-options">
                        <label for="dimensionPreset">Select Image Dimension:</label>
                            <select id="dimensionPreset">
                                <option value="custom">Custom Input</option>
                                 <option value="book">Book Mockup 1:1</option>
                                  <option value="thumbnail">Thumbnail 16:9</option>
                            </select>
                    </div>
               <div class="dimensions" style="display: flex; justify-content: center; align-items: center; margin-bottom: 15px;">
    <label for="width" style="margin-right: 5px;">Width:</label>
    <input type="number" id="width" placeholder="Width" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
     <label for="height" style="margin-left: 5px; margin-right: 5px;">Height:</label>
    <input type="number" id="height" placeholder="Height" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
</div>
                 <!-- Number of Images Select -->
                <div class="image-number-options">
                    <label for="numImages">Number of Images:</label>
                    <select id="numImages">
                        <option value="1">1</option>
                        <option value="2">2</option>
                        <option value="3">3</option>
                        <option value="4">4</option>
                        <option value="5">5</option>
                    </select>
                </div>
                <button type="submit">Generate Image</button>
                <div id="status"></div>
            </form>
            <div id="image-container" class="image-list"></div>
            <div id="history-container"></div>
        `;

        // Get a reference to the *newly created* elements
        promptTextarea = document.getElementById('prompt');
        promptCounter = document.getElementById('prompt-counter');
        promptWarning = document.getElementById('prompt-warning');
        widthInput = document.getElementById('width');
        heightInput = document.getElementById('height');
        dimensionPresetDropdown = document.getElementById('dimensionPreset');

        if (promptTextarea) {
            promptTextarea.addEventListener('input', updatePromptCounter);
            updatePromptCounter(); // Initial update
        }

        if(dimensionPresetDropdown){
            dimensionPresetDropdown.addEventListener('change', () => {
                updateDimensionInputs(dimensionPresetDropdown.value);
            });
            updateDimensionInputs(dimensionPresetDropdown.value); // Initial update
        }



        const userDetailsContainer = document.getElementById('user-details-container');
        const historyContainer = document.getElementById('history-container');
        //Fetch and Display user details
        function fetchAndDisplayUserDetails(){
            fetch('apis/getUserDetails.php?email=' + selectedEmail)
                .then(response => response.json())
                .then(data => {
                    if (data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json) {
                        const user = data[0].result.data.json;
                        const nextResetDate = new Date(user.next_reset_date);
                        const formattedResetDate = nextResetDate.toLocaleDateString(undefined, {
                            year: 'numeric',
                            month: 'long',
                            day: 'numeric',
                            hour: 'numeric',
                            minute: 'numeric'
                        });
                        const userDetailsHTML = `
                            <p><strong>Email:</strong> ${user.email}</p>
                            <p><strong>Credits Left:</strong> ${user.credits}</p>
                            <p><strong>Next Reset Date:</strong> ${formattedResetDate}</p><button id="login-btn" onclick="window.location.href='apis/authLoginWithPassword.php?email=${selectedEmail}'">Login</button>
                        `;
                        userDetailsContainer.innerHTML = userDetailsHTML;
                    } else {
                        userDetailsContainer.innerHTML = '<button id="login-btn" onclick="window.location.href=\'apis/authLoginWithPassword.php?email='+selectedEmail+'\'">Login</button>';
                    }
                })
                .catch(error => {
                    userDetailsContainer.innerHTML = '<button id="login-btn" onclick="window.location.href=\'apis/authLoginWithPassword.php?email='+selectedEmail+'\'">Login</button>';
                    console.error('Error:', error);
                });
        }
        fetchAndDisplayUserDetails();




        // Fetch and display image history on page load
        function fetchAndDisplayHistory() {
            fetch('apis/imageHistory.php?email=' + selectedEmail)
                .then(response => response.json())
                .then(data => {
                    if(data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json){
                        const history = data[0].result.data.json;
                        let historyHTML = '<ul>';
                        history.forEach(item => {
                            historyHTML += `<li>
                                    <div class="image-item-image"><img src="${item.s3_url}" alt="Generated Image"></div>
                                    <div class="image-item-details">
                                        <p><strong>Prompt:</strong> ${item.input_prompt}</p>
                                        <p><strong>Created At:</strong> ${item.created_at}</p>
                                        <div class="btn-container"><a class="download-btn" href="${item.s3_url}" download="image.jpg">Download</a></div>
                                    </div>
                                </li>`;
                        });
                        historyHTML += '</ul>';
                        historyContainer.innerHTML = historyHTML;
                    } else {
                        historyContainer.innerHTML = 'No images found in history.';
                    }

                })
                .catch(error=>{
                    historyContainer.innerHTML = 'Error fetching image history.';
                    console.error('Error:', error)
                });

        }
        fetchAndDisplayHistory();

        document.getElementById('imageForm').addEventListener('submit', function(event) {
            event.preventDefault();

            const prompt = document.getElementById('prompt').value;
            const width = document.getElementById('width').value;
            const height = document.getElementById('height').value;
            const numImages = parseInt(document.getElementById('numImages').value); // Get the selected number of images
            const statusDiv = document.getElementById('status');
            const imageContainer = document.getElementById('image-container');

            statusDiv.textContent = 'Generating...';
            imageContainer.innerHTML = '';

            let imagesGenerated = 0; // Track the number of images generated so far

            function generateImage() {
                fetch('apis/addTask.php?email=' + selectedEmail, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded',
                    },
                    body: 'prompt=' + encodeURIComponent(prompt) + '&width=' + encodeURIComponent(width) + '&height=' + encodeURIComponent(height),
                })
                    .then(response => response.json())
                    .then(data => {
                        if (data && data.error) {
                            statusDiv.textContent = 'Error: ' + data.error;
                        } else if (data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json && data[0].result.data.json[0]) {
                            const uuid = data[0].result.data.json[0].uuid;
                            // statusDiv.textContent = 'Status: ' + data[0].result.data.json[0].status; //initial status
                            // Start Polling function
                            pollForImage(uuid, statusDiv, imageContainer, selectedEmail, historyContainer, userDetailsContainer, () => {
                                imagesGenerated++; // Increment counter after successful generation
                                if (imagesGenerated < numImages) {
                                    generateImage(); // Call the function recursively
                                } else {
                                    statusDiv.textContent = 'All images generated successfully!';
                                }
                            });
                        } else {
                            statusDiv.textContent = 'Error generating image.';
                        }
                    })
                    .catch(error => {
                        statusDiv.textContent = 'Error generating image.';
                        console.error('Error:', error);
                    });
            }

            generateImage(); // Kick off the first image generation
        });
    }

     function pollForImage(uuid, statusDiv, imageContainer, email, historyContainer, userDetailsContainer, callback) { // Add callback
        let requestCount = 0; // Initialize request counter
        const interval = setInterval(() => {
            requestCount++; // Increment counter on each request
            fetch('apis/getTask.php?email=' + email, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                },
                body: 'uuid=' + encodeURIComponent(uuid),
            })
                .then(response => response.json())
                .then(data => {
                    if (data && data.error) {
                        statusDiv.textContent = 'Error: ' + data.error;
                        clearInterval(interval);
                        callback(); // Execute callback even on error
                    } else if (data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json && data[0].result.data.json[0]) {
                        const task = data[0].result.data.json[0];
                        if (task.status === 'processing') {
                             statusDiv.textContent = 'Processing... (Request #' + requestCount + ')';
                        } else if (task.status === 'completed' && task.s3_url) {
                            clearInterval(interval);
                             const imgElement = document.createElement('img');
                            imgElement.src = task.s3_url;
                            imgElement.alt = 'Generated Image';

                            // Add the new image to the *top* of the container
                            imageContainer.prepend(imgElement);
                            statusDiv.textContent = 'Image Generated Successfully';
                            fetchAndDisplayHistory();
                            fetchAndDisplayUserDetails();
                            callback(); // Execute callback on success

                        } else if (task.status === 'error') {
                            clearInterval(interval);
                            statusDiv.textContent = 'Error: ' + task.error_message;
                            callback(); // Execute callback even on error
                        }
                    } else {
                        statusDiv.textContent = 'Error generating image.';
                        clearInterval(interval);
                        callback(); // Execute callback even on error
                    }
                })
                .catch(error => {
                    statusDiv.textContent = 'Error generating image.';
                    clearInterval(interval);
                    console.error('Error:', error);
                    callback(); // Execute callback even on error
                });

        }, 1000); // Check every 1 second
    }
</script>
</body>
</html>