<?php

// Get the video ID from query parameter
$id = $_GET['id'] ?? '';

// Validate video ID
if (empty($id)) {
    echo "Invalid or missing video ID.";
    exit;
}


$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => 'https://outcast.ai/tools/api/get-youtube-transcript',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS => '{"videoUrl":"https://www.youtube.com/watch?v='.$id.'"}',
  CURLOPT_HTTPHEADER => [
    'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/132.0.6834.79 Mobile Safari/537.36',
  //  'Accept-Encoding: gzip, deflate, br, zstd',
    'Content-Type: application/json',
    'sec-ch-ua-platform: "Android"',
    'sec-ch-ua: "Not A(Brand";v="8", "Chromium";v="132", "Android WebView";v="132"',
    'sec-ch-ua-mobile: ?1',
    'origin: https://outcast.ai',
    'x-requested-with: mark.via.gp',
    'sec-fetch-site: same-origin',
    'sec-fetch-mode: cors',
    'sec-fetch-dest: empty',
    'referer: https://outcast.ai/tools/youtube-transcript-generator',
    'accept-language: en-US,en;q=0.9',
    'priority: u=1, i',
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

$data = json_decode($response, true);

// Check if decoding was successful and the data is an array
if ($data !== null && is_array($data)) {
    // Loop through each item in the array
    foreach ($data as $item) {
      //Check if the 'text' key exists
      if(isset($item['text'])){
        // Print the "text" value for each item
        echo $item['text'] . "\n";
      }
    }
} else {
    echo "Error: Unable to decode JSON or invalid data format.\n";
}

?>